﻿#include "StdAfx.h"
#include "CommonFunction.h"
#include "NeMessengerDlg.h"
#include "AESCrypto.h"
#include <iostream>
#include <string>
#include <sstream>
#include "ftlbase.h"
#include <gdiplus.h>

CNeMessengerDlg* g_pMain;
CNeMessengerDlg* GET_MESSENGER_DLG() { return g_pMain; }

CString g_strWorkingDirectory = _T("");

//굴림폰트설정
CFont g_ftGulim6PT;
CFont g_ftGulim7PT;
CFont g_ftGulim8PT;
CFont g_ftGulim9PT;
CFont g_ftGulim10PT;
//나눔폰트설정
CFont g_ftDefault6PT;
CFont g_ftDefault7PT;
CFont g_ftDefault8PT;
CFont g_ftDefault9PT;
CFont g_ftDefault10PT;
CFont g_ftDefault11PT;
CFont g_ftDefault12PT;
CFont g_ftDefault13PT;
CFont g_ftDefault14PT;

CFont g_ftDefault9PTB;
CFont g_ftDefault10PTB;
CFont g_ftDefault11PTB;

CFont g_ftDefault8PX;
CFont g_ftDefault9PX;
CFont g_ftDefault10PX;
CFont g_ftDefault11PX;
CFont g_ftDefault12PX;
CFont g_ftDefault13PX;
CFont g_ftDefault14PX;

CFont g_ftDefault12PXB;
CFont g_ftDefault13PXB;
CFont g_ftDefault14PXB;
CFont g_ftDefault15PXB;

//돋움체
CFont g_ftDotum10PX;
CFont g_ftDotum11PX;
CFont g_ftDotum12PX;
CFont g_ftDotum13PX;

CFont g_ftDotum10PXB;
CFont g_ftDotum11PXB;
CFont g_ftDotum12PXB;
CFont g_ftDotum13PXB;

bool g_bFavoriteListDlgOpened;

CBitmap m_bmpContentTop[3];
CBitmap m_bmpContentMiddle[2];
CBitmap m_bmpContentBottom[3];

using namespace std;

const TCHAR HEX2DEC[256] = 
{
	/* 0 1 2 3 4 5 6 7 8 9 A B C D E F */
	/* 0 */ -1,-1,-1,-1, -1,-1,-1,-1, -1,-1,-1,-1, -1,-1,-1,-1,
	/* 1 */ -1,-1,-1,-1, -1,-1,-1,-1, -1,-1,-1,-1, -1,-1,-1,-1,
	/* 2 */ -1,-1,-1,-1, -1,-1,-1,-1, -1,-1,-1,-1, -1,-1,-1,-1,
	/* 3 */ 0, 1, 2, 3, 4, 5, 6, 7, 8, 9,-1,-1, -1,-1,-1,-1,
	/* 4 */ -1,10,11,12, 13,14,15,-1, -1,-1,-1,-1, -1,-1,-1,-1,
	/* 5 */ -1,-1,-1,-1, -1,-1,-1,-1, -1,-1,-1,-1, -1,-1,-1,-1,
	/* 6 */ -1,10,11,12, 13,14,15,-1, -1,-1,-1,-1, -1,-1,-1,-1,
	/* 7 */ -1,-1,-1,-1, -1,-1,-1,-1, -1,-1,-1,-1, -1,-1,-1,-1,
	/* 8 */ -1,-1,-1,-1, -1,-1,-1,-1, -1,-1,-1,-1, -1,-1,-1,-1,
	/* 9 */ -1,-1,-1,-1, -1,-1,-1,-1, -1,-1,-1,-1, -1,-1,-1,-1,
	/* A */ -1,-1,-1,-1, -1,-1,-1,-1, -1,-1,-1,-1, -1,-1,-1,-1,
	/* B */ -1,-1,-1,-1, -1,-1,-1,-1, -1,-1,-1,-1, -1,-1,-1,-1,
	/* C */ -1,-1,-1,-1, -1,-1,-1,-1, -1,-1,-1,-1, -1,-1,-1,-1,
	/* D */ -1,-1,-1,-1, -1,-1,-1,-1, -1,-1,-1,-1, -1,-1,-1,-1,
	/* E */ -1,-1,-1,-1, -1,-1,-1,-1, -1,-1,-1,-1, -1,-1,-1,-1,
	/* F */ -1,-1,-1,-1, -1,-1,-1,-1, -1,-1,-1,-1, -1,-1,-1,-1
};
const TCHAR SAFE[256] =
{
	/* 0 1 2 3 4 5 6 7 8 9 A B C D E F */
	/* 0 */ 0,0,0,0, 0,0,0,0, 0,0,0,0, 0,0,0,0,
	/* 1 */ 0,0,0,0, 0,0,0,0, 0,0,0,0, 0,0,0,0,
	/* 2 */ 0,0,0,0, 0,0,0,0, 0,0,0,0, 0,0,0,0,
	/* 3 */ 1,1,1,1, 1,1,1,1, 1,1,0,0, 0,0,0,0,
	/* 4 */ 0,1,1,1, 1,1,1,1, 1,1,1,1, 1,1,1,1,
	/* 5 */ 1,1,1,1, 1,1,1,1, 1,1,1,0, 0,0,0,0,
	/* 6 */ 0,1,1,1, 1,1,1,1, 1,1,1,1, 1,1,1,1,
	/* 7 */ 1,1,1,1, 1,1,1,1, 1,1,1,0, 0,0,0,0,
	/* 8 */ 0,0,0,0, 0,0,0,0, 0,0,0,0, 0,0,0,0,
	/* 9 */ 0,0,0,0, 0,0,0,0, 0,0,0,0, 0,0,0,0,
	/* A */ 0,0,0,0, 0,0,0,0, 0,0,0,0, 0,0,0,0,
	/* B */ 0,0,0,0, 0,0,0,0, 0,0,0,0, 0,0,0,0,
	/* C */ 0,0,0,0, 0,0,0,0, 0,0,0,0, 0,0,0,0,
	/* D */ 0,0,0,0, 0,0,0,0, 0,0,0,0, 0,0,0,0,
	/* E */ 0,0,0,0, 0,0,0,0, 0,0,0,0, 0,0,0,0,
	/* F */ 0,0,0,0, 0,0,0,0, 0,0,0,0, 0,0,0,0
};


int BuddyItemComareFunc(const STRUCT_BUDDY_COMPARE elem1, const STRUCT_BUDDY_COMPARE elem2){

	int Sts1 = elem1.status;
	int Sts2 = elem2.status;

	CString Name1 = elem1.Name;
	CString Name2 = elem2.Name;
	if ((int)ustOFFLINE == Sts1 || (int)ustUnknown == Sts1)
	{
		Sts1 = 0x15;
	} 
	else
	{
		Sts1 = (int)ustONLINE;
	}

	if ((int)ustOFFLINE == Sts2 || (int)ustUnknown == Sts2)
	{
		Sts2 = 0x15;
	} 
	else
	{
		Sts2 = (int)ustONLINE;
	}

	if (Sts1 == Sts2)
	{
		//return Name1.CompareNoCase(Name2);
		return  StrCmp(Name1,Name2);
	}
	else{
		return (Sts1-Sts2);
	}


}


CString UrlEncode(CString aSrc)
{
	CString result(_T(""));
	const TCHAR DEC2HEX[16 + 1] = _T("0123456789ABCDEF");
	TCHAR *pSrc = aSrc.GetBuffer();
	const int SRC_LEN = aSrc.GetLength();
	TCHAR *pStart = new TCHAR[SRC_LEN * 3];
	if (NULL == pStart)
		return result;

	TCHAR *pEnd = pStart;
	TCHAR *SRC_END = pSrc + SRC_LEN;

	for (; pSrc < SRC_END; ++pSrc)
	{
		if (SAFE[*pSrc])
		{
			*pEnd++ = *pSrc;
		}
		else if (*pSrc >= 256)
		{
			*pEnd++ = *pSrc;
		}
		else
		{
			// escape this char
			*pEnd++ = '%';
			*pEnd++ = DEC2HEX[*pSrc >> 4];
			*pEnd++ = DEC2HEX[*pSrc & 0x0F];
		}
	}
	size_t length = pEnd - pStart;
	size_t index;

	for (index = 0; index < length; index++)
	{
		result += pStart[index];
	}
	delete [] pStart;
	return result;
}


CString String2CString(std::string str)
{
	UINT nLen = MultiByteToWideChar(CP_ACP, 0, (LPCSTR)str.c_str(), -1, NULL, 0);
	TCHAR *buf = new TCHAR[nLen];
	if (NULL == buf)
		return CString("");

	MultiByteToWideChar(CP_ACP, MB_PRECOMPOSED, (LPCSTR)str.c_str(), -1, buf, nLen);
	CString strReturn(buf);
	delete[] buf;

	return strReturn;
}
std::wstring AnsiToUnicode(const std::string& s)
{
	std::wstring ret(s.length(),' ');
	std::copy(s.begin(), s.end(), ret.begin());
	return ret;
}

std::string UTF8ToANSI(char *pszCode)
{
	BSTR bstrWide;
	char* pszAnsi;
	int nLength;
	// bstrWide 배열 생성 Lenth를 읽어 온다.
	nLength = MultiByteToWideChar(CP_UTF8, 0, pszCode, strlen(pszCode) + 1, NULL, NULL);
	// bstrWide 메모리 설정
	bstrWide = SysAllocStringLen(NULL, nLength);
	MultiByteToWideChar(CP_UTF8, 0, pszCode, strlen(pszCode) + 1, bstrWide, nLength);
	// char 배열 생성전 Lenth를 읽어 온다.
	nLength = WideCharToMultiByte(CP_ACP, 0, bstrWide, -1, NULL, 0, NULL, NULL);
	// pszAnsi 배열 생성
	pszAnsi = new char[nLength];
	if (NULL == pszAnsi)
	{
        SysFreeString(bstrWide);
		return "";
	}
	// char 변환
	WideCharToMultiByte(CP_ACP, 0, bstrWide, -1, pszAnsi, nLength, NULL, NULL);
	// bstrWide 메모리 해제
	SysFreeString(bstrWide);

	std::string returnString(pszAnsi);

	delete [] pszAnsi;

	return returnString;
}





void Trace(TCHAR* szFormat, ...)
{
	TCHAR szTempBuf[4096] ;
	va_list vlMarker ;

	va_start(vlMarker,szFormat) ;
	vswprintf_s(szTempBuf,4096,szFormat,vlMarker) ;
	va_end(vlMarker) ;

	OutputDebugString(szTempBuf) ;
}

HFONT CreateSmartFont(LPCTSTR pszFaceName,int nFontSize,int nFontWeight, BOOL bItalic, BOOL bUnderline, UINT nQuality)
{
	HDC hDC=::GetDC(NULL);

	if(hDC == NULL)
		return NULL;

	CFont ftFont;
	ftFont.CreateFont(-MulDiv(nFontSize, GetDeviceCaps(hDC, LOGPIXELSY), 72),
		0, 0, 0, nFontWeight, bItalic, bUnderline, 0, DEFAULT_CHARSET, 0, 0, nQuality, 0, pszFaceName);
	::ReleaseDC(NULL,hDC);




	return (HFONT)ftFont.Detach();
}

HFONT CreateSmartPixelFont(LPCTSTR pszFaceName,int nFontSize,int nFontWeight, BOOL bItalic, BOOL bUnderline, UINT nQuality)
{


	CFont ftFont;
	ftFont.CreateFont(nFontSize,
		0, 0, 0, nFontWeight, bItalic, bUnderline, 0, DEFAULT_CHARSET, 0, 0, nQuality, 0, pszFaceName);

	return (HFONT)ftFont.Detach();
}




void SetWorkingDirectory(LPCTSTR pszWorkingPath)
{
	g_strWorkingDirectory = pszWorkingPath;

	if(g_strWorkingDirectory.IsEmpty())
		return;

	if(g_strWorkingDirectory.Right(1).Compare(_T("\\")) == 0 || 
		g_strWorkingDirectory.Right(1).Compare(_T("/")) == 0)
	{
		//Do Nothing
	}
	else
	{
		g_strWorkingDirectory += _T("\\");
	}
}

CString GetWorkingDirectory()
{
	return g_strWorkingDirectory;
}


HBITMAP LoadImageFromPath(LPCTSTR pszPath)
{
	CString strPath = pszPath;
	if(strPath.GetLength()==0)
		return NULL;

	strPath.MakeLower();

	ChangeToWorkingDirectory(strPath);

	if(strPath.Right(4)==_T(".bmp"))
	{
		return (HBITMAP)::LoadImage(::AfxGetInstanceHandle(),strPath, IMAGE_BITMAP,0,0,LR_LOADFROMFILE);
	}
	else
	{
		CImage Image;
		//if(pszPath)
		{
			HRESULT hr=Image.Load(strPath);
			if(hr==0)
			{
				return Image.Detach();
			}
			else
			{
				CString strMessage;
				strMessage.Format(_T("Failed to load bitmap . file=%s hresult=%d\n"), strPath, hr);
				TRACE(strMessage);
				ASSERT(0);  //lint !e527
				return NULL;
			}
		}
	}//lint !e527
	return NULL;
}

bool LoadBitmapFromPath(CBitmap& bmpImage,LPCTSTR pszPath)
{
	HBITMAP hBmp=LoadImageFromPath(pszPath);
	if(hBmp)
	{
		bmpImage.DeleteObject();
		bmpImage.Attach(hBmp);
		return TRUE;
	}

	return FALSE;
}


bool GetIndexBitmapFromImage(CBitmap& bmpSlice,CBitmap& bmpTotalImage,int nIndex,int nSliceCount)
{
	if(!bmpTotalImage.GetSafeHandle() || nSliceCount<=0 || nIndex<0 || nIndex>=nSliceCount)
	{
		return false;
	}

	HDC hDC=GetDC(NULL);
	CDC *pDC=CDC::FromHandle(hDC);

	CDC dcSlice;
	dcSlice.CreateCompatibleDC(pDC);

	CDC dcTotal;
	dcTotal.CreateCompatibleDC(pDC);
	CBitmap* pOldBmpTotal = dcTotal.SelectObject(&bmpTotalImage);

	BITMAP bmInfo;
	bmpTotalImage.GetBitmap(&bmInfo);

	int nWidth=bmInfo.bmWidth/nSliceCount;
	int nHeight=bmInfo.bmHeight;

	bmpSlice.DeleteObject();
	bmpSlice.CreateCompatibleBitmap(pDC,nWidth,nHeight);
	CBitmap* pOldBmpSlice = dcSlice.SelectObject(&bmpSlice);

	VERIFY(dcSlice.BitBlt(0,0,nWidth,nHeight,&dcTotal,nIndex*nWidth,0,SRCCOPY));

    dcTotal.SelectObject(pOldBmpTotal);
    dcSlice.SelectObject(pOldBmpSlice);

	dcSlice.DeleteDC();
	dcTotal.DeleteDC();
	ReleaseDC(NULL,hDC);

	return true;
}

HRESULT ExplorerToSpecialFile(const CString& strFilePath)
{
	HRESULT hr = E_FAIL;

	PIDLIST_RELATIVE pidl = NULL;
	//ULONG attributes = 0;
	SFGAOF sfgaofIn = 0, sfgaofOut = 0;

	CString strFullPath = strFilePath;
	PTSTR pszBuf = strFullPath.GetBuffer();

	hr = SHParseDisplayName(pszBuf, NULL,	&pidl, sfgaofIn, &sfgaofOut);
	if (SUCCEEDED(hr))
	{
		hr = SHOpenFolderAndSelectItems(pidl, 0, NULL, 0);
		//ILFree(pidl);
		CoTaskMemFree(pidl);
		pidl = NULL;
	}

	strFullPath.ReleaseBuffer();
	return hr;
}

static char __base64_table[] ={
	'A', 'B', 'C', 'D', 'E', 'F', 'G', 'H', 'I', 'J', 'K', 'L', 'M',
	'N', 'O', 'P', 'Q', 'R', 'S', 'T', 'U', 'V', 'W', 'X', 'Y', 'Z',
	'a', 'b', 'c', 'd', 'e', 'f', 'g', 'h', 'i', 'j', 'k', 'l', 'm',
	'n', 'o', 'p', 'q', 'r', 's', 't', 'u', 'v', 'w', 'x', 'y', 'z',
	'0', '1', '2', '3', '4', '5', '6', '7', '8', '9', '+', '/', '\0'
};
static char __base64_pad = '=';


unsigned char *base64_encode(unsigned char *str, int length, int *ret_length)
{
	const unsigned char *current = str;
	int i = 0;
	unsigned char *result = (unsigned char *)malloc(((length + 3 - length % 3) * 4 / 3 + 1) * sizeof(char));

	if (NULL == result)
	{
		return NULL;
	}

	while (length > 2) { /* keep going until we have less than 24 bits */
		result[i++] = __base64_table[current[0] >> 2];
		result[i++] = __base64_table[((current[0] & 0x03) << 4) + (current[1] >> 4)];
		result[i++] = __base64_table[((current[1] & 0x0f) << 2) + (current[2] >> 6)];
		result[i++] = __base64_table[current[2] & 0x3f];

		current += 3;
		length -= 3; /* we just handle 3 octets of data */
	}

	/* now deal with the tail end of things */
	if (length != 0) {
		result[i++] = __base64_table[current[0] >> 2];
		if (length > 1) {
			result[i++] = __base64_table[((current[0] & 0x03) << 4) + (current[1] >> 4)];
			result[i++] = __base64_table[(current[1] & 0x0f) << 2];
			result[i++] = __base64_pad;

		} else {
			result[i++] = __base64_table[(current[0] & 0x03) << 4];
			result[i++] = __base64_pad;
			result[i++] = __base64_pad;
		}
	}

	if(ret_length) {
		*ret_length = i;
	}
	result[i] = '\0';

	return result;
}




unsigned char *base64_decode(unsigned char *str, int *ret_length) 
{
	if (str == NULL)
		return NULL;

	const unsigned char *current = str;
	int ch, i = 0, j = 0, k;
	/* this sucks for threaded environments */
	static short reverse_table[256];
	static int table_built;
	unsigned char *result;
	int length = 0;

	// added by shell - 인자하나 덜 받을라고.. ^^*
	if(str) length = strlen((char *)str);

	if (++table_built == 1) {
		char *chp;
		for(ch = 0; ch < 256; ch++) {
			chp = strchr(__base64_table, ch);
			if(chp) {
				reverse_table[ch] = chp - __base64_table;
			} else {
				reverse_table[ch] = -1;
			}
		}
	}

	result = (unsigned char *)malloc(length + 1);
	if (result == NULL) {
		return NULL;
	}

	/* run through the whole string, converting as we go */
	while ((ch = *current++) != '\0') {
		if (ch == __base64_pad) {
			break;
		}

		/* When Base64 gets POSTed, all pluses are interpreted as spaces.
		This line changes them back.  It's not exactly the Base64 spec,
		but it is completely compatible with it (the spec says that
		spaces are invalid).  This will also save many people considerable
		headache.  - Turadg Aleahmad <turadg@wise.berkeley.edu>
		*/

		if (ch == ' ') {
			ch = '+';
		}

		ch = reverse_table[ch];
		if (ch < 0) {
			continue;
		}

		switch(i % 4) {
			case 0:
				result[j] = ch << 2;
				break;

			case 1:
				result[j++] |= ch >> 4;
				result[j] = (ch & 0x0f) << 4;
				break;

			case 2:
				result[j++] |= ch >>2;
				result[j] = (ch & 0x03) << 6;
				break;

			case 3:
				result[j++] |= ch;
				break;
		}
		i++;
	}

	k = j;
	/* mop things up if we ended on a boundary */
	if (ch == __base64_pad) {
		switch(i % 4) {
		case 0:
		case 1:
			free(result);
			return NULL;
		case 2:
			k++;
		case 3:
			result[k++] = 0;
		}
	}

	if(ret_length) {
		*ret_length = j;
	}

	result[k] = '\0';

	return result;
}

bool MultiplyAlpha(CImage& image)
{
	if(image.IsNull())
		return false;

	register LPBYTE lpImage=(LPBYTE)image.GetBits();
	if(image.GetPitch()<0)
	{
		lpImage = lpImage + ((image.GetHeight()-1) * image.GetPitch());
	}

	if(image.GetBPP()==32)
	{
		int nWidth=image.GetWidth();
		int nHeight=image.GetHeight();

		register LPBYTE r,g,b,a;
		for(int y=0;y<nHeight;y++)
		{
			for(int x=0;x<nWidth;x++)
			{
				r=lpImage++;
				g=lpImage++;
				b=lpImage++;
				a=lpImage++;

				*r=(BYTE)(((UINT)(*r) * (*a))/255);
				*g=(BYTE)(((UINT)(*g) * (*a))/255);
				*b=(BYTE)(((UINT)(*b) * (*a))/255);
			}
		}
	}

	return true;
}

int EncryptSIP(IN LPCTSTR strID, IN char* szPlainMsg, OUT unsigned char* byteEncryptedMsg)
{
	CAESCrypto crypto;
	char szKeyTable[] = 
		"0ZO67A8d60SM0uZvZlU347DGHmVt9505pxh447U2gx8BNO342r6gin4STd9t9x7A2qHI8ukxDyw9nG5o2491xg82w707MMrdS1Zrn8QAP3Za23F4E8HsxVWTyNuFPmFNPc2dlInGyBR6w2s80Nfx16";
	char *pszAnsiID = NULL;
	char *pEncData = NULL;

	char szSeed[SIPENC_BUFF_SIZE] = {0,};	

	int nEncryptedMsgLen = 0;
	int nB64Len = 0;

	USES_CONVERSION;

	pszAnsiID = W2A(strID);
	crypto.Base64Encode((const BYTE*)pszAnsiID, strlen(pszAnsiID), szSeed, &nB64Len);	

	bool result = crypto.pwdcrypt_encrypt(szPlainMsg, strlen(szPlainMsg), (unsigned char *)byteEncryptedMsg, &nEncryptedMsgLen, szSeed, szKeyTable, strlen(szKeyTable));

	if (false == result)
	{
		nEncryptedMsgLen = 0;
	}

	return nEncryptedMsgLen;
}

void DecryptSIP(IN LPCTSTR strID, IN unsigned char* byteEncMsg, IN int nEncSize, OUT char* szPlainMsg)
{	
	CAESCrypto crypto;
	char szKeyTable[] = 
		"0ZO67A8d60SM0uZvZlU347DGHmVt9505pxh447U2gx8BNO342r6gin4STd9t9x7A2qHI8ukxDyw9nG5o2491xg82w707MMrdS1Zrn8QAP3Za23F4E8HsxVWTyNuFPmFNPc2dlInGyBR6w2s80Nfx16";

	char *pszAnsiID = NULL;
	char *pDecData = NULL;

	char szSeed[SIPENC_BUFF_SIZE] = {0,};	

	int nDecLen = 0;
	int nB64Len = 0;

	USES_CONVERSION;

	pszAnsiID = W2A(strID);
	crypto.Base64Encode((const BYTE*)pszAnsiID, strlen(pszAnsiID), szSeed, &nB64Len);	

	crypto.pwdcrypt_decrypt((unsigned char *)byteEncMsg, nEncSize, szPlainMsg, &nDecLen, szSeed, szKeyTable, strlen(szKeyTable));		

}

CString GetHddSerial()
{
	CString strSerial;
	DWORD dwSerialNumber;
	GetVolumeInformation(_T("c:\\"), NULL, 0, &dwSerialNumber, NULL, NULL, NULL, 0);
	strSerial.Format(_T("%d"), dwSerialNumber);

	return strSerial;
}

//CString GetWorkingDirectory()
//{
//	return ;
//}

WCHAR* g_defaultFontFaceName;

WCHAR* GetDefaultFontFaceNameW()
{
	CString defaultFontFaceName;

	if(g_stNtalkInfo.nLang == NTALK_LANG_JAPANESE)
	{
		return DEFAULT_JAPANESE_FONT_NAME;
	}
	else if(g_stNtalkInfo.nLang == NTALK_LANG_CHINESE_SIMPLIFIED)
	{
		return DEFAULT_CHINESE_FONT_NAME;
	}
	else if(g_stNtalkInfo.nLang == NTALK_LANG_CHINESE_TRADITIONAL)
	{
		return DEFAULT_CHINESE_FONT_NAME;
	}
	else
	{
		return DEFAULT_KOREAN_FONT_NAME;
	}

	return DEFAULT_KOREAN_FONT_NAME;
}

CString GetDefaultFontFaceName()
{
	CString defaultFontFaceName;

	if(g_stNtalkInfo.nLang == NTALK_LANG_JAPANESE)
	{
		defaultFontFaceName = DEFAULT_JAPANESE_FONT_NAME_T;
	}
	else if(g_stNtalkInfo.nLang == NTALK_LANG_CHINESE_SIMPLIFIED)
	{
		defaultFontFaceName = DEFAULT_CHINESE_FONT_NAME_T;
	}
	else if(g_stNtalkInfo.nLang == NTALK_LANG_CHINESE_TRADITIONAL)
	{
		defaultFontFaceName = DEFAULT_CHINESE_FONT_NAME_T;
	}
	else if(g_stNtalkInfo.nLang == NTALK_LANG_ENGLISH)
	{
		defaultFontFaceName = DEFAULT_ENGLISH_FONT_NAME_T;
	}	
	else
	{
		defaultFontFaceName = DEFAULT_KOREAN_FONT_NAME_T;
	}

	return defaultFontFaceName;
}

int GetDefaultFontIndex()
{
    int nFontIndex = 0;
    switch (g_stNtalkInfo.nLang)
    {
    case NTALK_LANG_ENGLISH:
        nFontIndex = 1;
        break;
    case NTALK_LANG_JAPANESE:
        nFontIndex = 2;
        break;
    case NTALK_LANG_CHINESE_SIMPLIFIED:
        nFontIndex = 0;
        break;
    case NTALK_LANG_CHINESE_TRADITIONAL:
        nFontIndex = 0;
        break;
    case NTALK_LANG_KOREAN:
    default:
        nFontIndex = 1;
        break;
    }
    return nFontIndex;
}

void ChangeToWorkingDirectory( CString &strPath )
{
	if(strPath.IsEmpty())
	{
		ASSERT(0);  //lint !e527
		return;
	}

	//상대값으로 들어온 path를 절대값으로 수정함
	if(strPath.Mid(1, 2).Compare(_T(":\\")) == 0 ||
		strPath.Mid(1, 2).Compare(_T(":/")) == 0)
	{
		//Do Nothing
	}
	else
	{
		if( (strPath.Left(2).Compare(_T("./"))==0) ||
			(strPath.Left(2).Compare(_T(".\\"))==0) )
		{
			strPath=strPath.Mid(2);
		}
		strPath = GetWorkingDirectory() + strPath;
	}
}



void SetWindowPosToSide(CWnd * pWndParent, CWnd * pWndChild, bool bLeftFirst)
{
	if(pWndParent->IsWindowVisible())
	{
		CRect rcWindowParent, rcWindowChild, rcWorkArea, rcVirtualDesktop;

		SystemParametersInfo(SPI_GETWORKAREA, 0, &rcWorkArea, 0);
		rcVirtualDesktop.left=GetSystemMetrics(SM_XVIRTUALSCREEN);
		rcVirtualDesktop.top=GetSystemMetrics(SM_YVIRTUALSCREEN);
		rcVirtualDesktop.right=rcVirtualDesktop.left+GetSystemMetrics(SM_CXVIRTUALSCREEN);
		rcVirtualDesktop.bottom=rcVirtualDesktop.top+GetSystemMetrics(SM_CYVIRTUALSCREEN);

		pWndParent->GetWindowRect(rcWindowParent);
		pWndChild->GetWindowRect(rcWindowChild);

		bool bEnableToLeft  = false;
		bool bEnableToRight = false;
		bool bFinalPositionIsLeft = true;

		//Left가능 부터 확인
		if(rcWindowParent.left >= 0 && rcWindowParent.right <= rcWorkArea.right &&
			(rcWindowParent.left - rcWindowChild.Width() > 0) )      
		{
			//WorkArea에 있는경우
			bEnableToLeft = true;
		}
		else if(rcWindowParent.left < 0 && rcVirtualDesktop.left < 0 &&
			(rcWindowParent.left - rcWindowChild.Width() > rcVirtualDesktop.left) )
		{
			//좌측 sub모니터에 존재하는 경우
			bEnableToLeft = true;
		}
		else if(rcWindowParent.left > rcWorkArea.right && rcVirtualDesktop.right > rcWorkArea.right && 
			(rcWindowParent.left - rcWindowChild.Width() > rcWorkArea.right) )
		{
			//우측 sub모니터에 존재하는 경우
			bEnableToLeft = true;
		}

		//Right가능 확인
		if(rcWindowParent.left >= 0 && rcWindowParent.right <= rcWorkArea.right &&
			rcWindowParent.right + rcWindowChild.Width() < rcWorkArea.right)
		{
			//WorkArea에 있는경우 rcWindowParent.right <= rcWorkArea.right
			bEnableToRight = true;
		}
		else if(rcWindowParent.right < 0 && rcVirtualDesktop.left < 0 &&
			rcWindowParent.right + rcWindowChild.Width() < 0)
		{
			//좌측 sub모니터에 존재하는 경우
			bEnableToRight = true;
		}

		else if(rcWindowParent.right > rcWorkArea.right && rcVirtualDesktop.right > rcWorkArea.right &&
			rcWindowParent.right + rcWindowChild.Width() < rcVirtualDesktop.right)
		{
			//우측 sub모니터에 존재하는 경우
			bEnableToRight = true;
		}

		if(bEnableToLeft || bEnableToRight)
		{
			if(bEnableToLeft && bEnableToRight)
			{
				if(bLeftFirst)
					bFinalPositionIsLeft = true;
				else
					bFinalPositionIsLeft = false;
			}
			else
			{
				bFinalPositionIsLeft = bEnableToLeft;
			}

			if(bFinalPositionIsLeft)
				pWndChild->SetWindowPos(0, rcWindowParent.left - rcWindowChild.Width(),
				rcWindowParent.top, 0, 0, SWP_NOZORDER | SWP_NOSIZE);
			else
				pWndChild->SetWindowPos(0, rcWindowParent.right,
				rcWindowParent.top, 0, 0, SWP_NOZORDER | SWP_NOSIZE);

			return;
		}
	}

	pWndChild->CenterWindow();
}


// 문자열 쓰기
BOOL reg_WriteString(HKEY hKey, TCHAR* lpKey, TCHAR* lpValue, TCHAR* lpData, BOOL bFlush)
{
	HKEY key;
	DWORD dwDisp;

	if(RegCreateKeyEx(hKey,lpKey,0,NULL,REG_OPTION_NON_VOLATILE,KEY_WRITE,NULL,&key,&dwDisp) != ERROR_SUCCESS)
	{
		return FALSE;
	}
	//
	if(lpData == NULL)
		if(RegSetValueEx(key,lpValue,0,REG_SZ,(LPBYTE)lpData,0) != ERROR_SUCCESS)
			return FALSE;
	//
	if(lpData)
		if(RegSetValueEx(key,lpValue,0,REG_SZ,(LPBYTE)lpData,(wcslen(lpData)+1)*2) != ERROR_SUCCESS)
			return FALSE;

	if(bFlush)
		RegFlushKey(key);
	RegCloseKey(key);
	return TRUE;
}

//문자열 읽기
BOOL reg_ReadString(HKEY hKey,TCHAR* lpKey, TCHAR* lpValue, TCHAR* lpDefault,TCHAR* lpRet,DWORD nSize)
{
	HKEY key;
	DWORD dwDisp=0;
	DWORD Size=0;

	if(RegCreateKeyEx(hKey,lpKey,0,NULL,
		REG_OPTION_NON_VOLATILE,KEY_READ,NULL,&key,&dwDisp) != ERROR_SUCCESS)
		return 0;
	Size = nSize;

	if(RegQueryValueEx(key,lpValue,0,NULL,(unsigned char *)lpRet,&Size) != ERROR_SUCCESS)
	{
		if(lpDefault == NULL)
			lpRet = NULL;
		else if (lpDefault != NULL)
		{
			wsprintf(lpRet,TEXT("%s"),lpDefault);
			if(hKey == SHCU)
				reg_WriteString(hKey,lpKey,lpValue,lpRet);
		}

		return FALSE;
	}

	RegCloseKey(key);
	return TRUE;
}

//지우기
BOOL reg_DeleteValue(HKEY hKey, TCHAR* lpKey, TCHAR* lpValue)
{
	HKEY key;
	if(RegOpenKeyEx(hKey,lpKey,0,KEY_SET_VALUE,&key) != ERROR_SUCCESS)
		return FALSE;

	if(RegDeleteValue(key,lpValue)!= ERROR_SUCCESS)
		return FALSE;
	RegCloseKey(key);
	return TRUE;
}







void GetContentBG(CBitmap& bmpBG, LPRECT lpRectContent, CDC* pDC)
{
	// 이미지가 없으면 이미지 로드
	if(!m_bmpContentTop[0].GetSafeHandle())
	{
		LoadBitmapFromPath( m_bmpContentTop[0], _T("kor\\alert\\IMbox_Top_Left.bmp"));
		LoadBitmapFromPath( m_bmpContentTop[1], _T("kor\\alert\\IMbox_Top_Center.bmp"));
		LoadBitmapFromPath( m_bmpContentTop[2], _T("kor\\alert\\IMbox_Top_Right.bmp"));
	}
	if(!m_bmpContentMiddle[0].GetSafeHandle())
	{
		LoadBitmapFromPath( m_bmpContentMiddle[0], _T("kor\\alert\\IMbox_Middle_Left.bmp"));
		LoadBitmapFromPath( m_bmpContentMiddle[1], _T("kor\\alert\\IMbox_Middle_Right.bmp"));
	}
	if(!m_bmpContentBottom[0].GetSafeHandle())
	{
		LoadBitmapFromPath( m_bmpContentBottom[0], _T("kor\\alert\\IMbox_Bottom_Left.bmp"));
		LoadBitmapFromPath( m_bmpContentBottom[1], _T("kor\\alert\\IMbox_Bottom_Center.bmp"));
		LoadBitmapFromPath( m_bmpContentBottom[2], _T("kor\\alert\\IMbox_Bottom_Right.bmp"));
	}

	// Create Bitmap
	CRect rcContent(lpRectContent);

	if(bmpBG.GetSafeHandle())
		bmpBG.DeleteObject();

	CDC* pParentDC = pDC;
	if(!pParentDC)
		pParentDC = CDC::FromHandle(::GetDC(NULL));
	bmpBG.CreateCompatibleBitmap(pParentDC, rcContent.Width(), rcContent.Height());

	CDC dcBG;
	dcBG.CreateCompatibleDC(pParentDC);
	dcBG.SelectObject(&bmpBG);
	rcContent.OffsetRect(-rcContent.left, -rcContent.top);

	dcBG.FillSolidRect(rcContent,RGB(255,255,255));
	dcBG.SetStretchBltMode(HALFTONE);

	if(m_bmpContentTop[0].GetSafeHandle() && m_bmpContentTop[1].GetSafeHandle() && m_bmpContentTop[2].GetSafeHandle())
	{
		CRect rcTop(rcContent);

		CDC dcSlice;
		dcSlice.CreateCompatibleDC(&dcBG);

		BITMAP bmInfo;
		ZeroMemory(&bmInfo, sizeof(BITMAP));

		dcSlice.SelectObject(&m_bmpContentTop[0]);
		m_bmpContentTop[0].GetBitmap(&bmInfo);
		rcTop.bottom = rcTop.top + bmInfo.bmHeight;
		rcContent.top += bmInfo.bmHeight;
		dcBG.BitBlt(rcTop.left,rcTop.top,bmInfo.bmWidth,bmInfo.bmHeight, &dcSlice,0,0, SRCCOPY);
		rcTop.left += bmInfo.bmWidth;

		dcSlice.SelectObject(&m_bmpContentTop[2]);
		m_bmpContentTop[2].GetBitmap(&bmInfo);
		rcTop.right -= bmInfo.bmWidth;
		dcBG.BitBlt(rcTop.right,rcTop.top,bmInfo.bmWidth,bmInfo.bmHeight, &dcSlice,0,0, SRCCOPY);

		dcSlice.SelectObject(&m_bmpContentTop[1]);
		m_bmpContentTop[1].GetBitmap(&bmInfo);
		dcBG.StretchBlt(rcTop.left,rcTop.top,rcTop.Width(),rcTop.Height(), 
			&dcSlice,0,0,bmInfo.bmWidth,bmInfo.bmHeight, SRCCOPY);
	}

	if(m_bmpContentBottom[0].GetSafeHandle() && m_bmpContentBottom[1].GetSafeHandle() && m_bmpContentBottom[2].GetSafeHandle())
	{
		CRect rcBottom(rcContent);

		CDC dcSlice;
		dcSlice.CreateCompatibleDC(&dcBG);

		BITMAP bmInfo;
		ZeroMemory(&bmInfo, sizeof(BITMAP));

		dcSlice.SelectObject(&m_bmpContentBottom[0]);
		m_bmpContentBottom[0].GetBitmap(&bmInfo);
		rcBottom.top = rcBottom.bottom - bmInfo.bmHeight;
		rcContent.bottom -= bmInfo.bmHeight;
		dcBG.BitBlt(rcBottom.left,rcBottom.top,bmInfo.bmWidth,bmInfo.bmHeight, &dcSlice,0,0, SRCCOPY);
		rcBottom.left += bmInfo.bmWidth;

		dcSlice.SelectObject(&m_bmpContentBottom[2]);
		m_bmpContentBottom[2].GetBitmap(&bmInfo);
		rcBottom.right -= bmInfo.bmWidth;
		dcBG.BitBlt(rcBottom.right,rcBottom.top,bmInfo.bmWidth,bmInfo.bmHeight, &dcSlice,0,0, SRCCOPY);

		dcSlice.SelectObject(&m_bmpContentBottom[1]);
		m_bmpContentBottom[1].GetBitmap(&bmInfo);
		dcBG.StretchBlt(rcBottom.left,rcBottom.top,rcBottom.Width(),rcBottom.Height(), 
			&dcSlice,0,0,bmInfo.bmWidth,bmInfo.bmHeight, SRCCOPY);
	}

	if(m_bmpContentMiddle[0].GetSafeHandle() && m_bmpContentMiddle[1].GetSafeHandle())
	{
		CDC dcSlice;
		dcSlice.CreateCompatibleDC(&dcBG);

		BITMAP bmInfo;
		ZeroMemory(&bmInfo, sizeof(BITMAP));

		dcSlice.SelectObject(&m_bmpContentMiddle[0]);
		m_bmpContentMiddle[0].GetBitmap(&bmInfo);
		dcBG.StretchBlt(rcContent.left,rcContent.top,bmInfo.bmWidth,rcContent.Height(), 
			&dcSlice,0,0,bmInfo.bmWidth,bmInfo.bmHeight, SRCCOPY);

		dcSlice.SelectObject(&m_bmpContentMiddle[1]);
		m_bmpContentMiddle[1].GetBitmap(&bmInfo);
		rcContent.right -= bmInfo.bmWidth;
		dcBG.StretchBlt(rcContent.right,rcContent.top,bmInfo.bmWidth,rcContent.Height(),
			&dcSlice,0,0,bmInfo.bmWidth,bmInfo.bmHeight, SRCCOPY);
	}

	if(!pDC && pParentDC)
		::ReleaseDC(NULL, pParentDC->GetSafeHdc());
}

void DrawContentBG(CDC* pDC, LPRECT lpRectContent)
{
	CRect rcContent(lpRectContent);

	CBitmap bmpBG;
	GetContentBG(bmpBG, rcContent, pDC);

	CDC dcBmp;
	dcBmp.CreateCompatibleDC(pDC);
	dcBmp.SelectObject(&bmpBG);
	rcContent.OffsetRect(-rcContent.left, -rcContent.top);

	BITMAP bmInfo;
	ZeroMemory(&bmInfo, sizeof(BITMAP));
	bmpBG.GetBitmap(&bmInfo);

	//pDC->BitBlt(lpRectContent->left,lpRectContent->top,rcContent.Width(),rcContent.Height(),
	//    &dcBmp,0,0, SRCCOPY);

	pDC->TransparentBlt(lpRectContent->left,lpRectContent->top,rcContent.Width(),rcContent.Height(),
		&dcBmp,0,0,bmInfo.bmWidth,bmInfo.bmHeight, RGB(255,0,255));
}


CString GetLanguageStringUnicode()
{
    std::string lang = GetLanguageString();
	//CComVariant URL(lang.c_str());
	//CString strLang = URL.bstrVal;
    FTL::CFConversion conv;
    CString strLang = conv.UTF8_TO_TCHAR(lang.c_str());
	return strLang;
}

const std::string GetLanguageString()
{
	const char* korean = "ko_KR";
	const char* english = "en_US";
	const char* japanese = "ja_JP";
	const char* simplifiedChinise = "zh_CN";
	const char* traditioanChinese = "zh_TW";

	std::string lang;

	if(g_stNtalkInfo.nLang == NTALK_LANG_KOREAN) //kor
	{
		lang = korean;
	}
	else if(g_stNtalkInfo.nLang == NTALK_LANG_ENGLISH) //eng
	{
		lang = english;
	}
	else if(g_stNtalkInfo.nLang == NTALK_LANG_JAPANESE)
	{
		lang = japanese;
	}
	else if(g_stNtalkInfo.nLang == NTALK_LANG_CHINESE_TRADITIONAL)
	{
		lang = simplifiedChinise;
	}
	else if(g_stNtalkInfo.nLang == NTALK_LANG_CHINESE_SIMPLIFIED)
	{
		lang = traditioanChinese;
	}

	return lang;
}

std::string UriEncode(const std::string & sSrc)
{
	const char *DEC2HEX = "0123456789ABCDEF";
	const unsigned char * pSrc = (const unsigned char *)sSrc.c_str();
	const int SRC_LEN = sSrc.length();
	unsigned char * const pStart = new unsigned char[SRC_LEN * 3];
	if (NULL == pStart)
	{
		return "";
	}

	unsigned char * pEnd = pStart;
	const unsigned char * const SRC_END = pSrc + SRC_LEN;

	for (; pSrc < SRC_END; ++pSrc)
	{
		if (SAFE[*pSrc]) 
			*pEnd++ = *pSrc;
		else
		{
			// escape this char
			*pEnd++ = '%';
			*pEnd++ = DEC2HEX[*pSrc >> 4];
			*pEnd++ = DEC2HEX[*pSrc & 0x0F];
		}
	}

	std::string sResult((char *)pStart, (char *)pEnd);
	delete [] pStart;
	return sResult;
}
//
//void ResponseWebData( CHttpFile * pFile, std::string &strResult) 
//{
//	const int BufferSize = 4096;
//	char buffer[BufferSize];
//
//	DWORD readCount;
//
//	while(true)
//	{
//		readCount = pFile->Read(buffer, BufferSize);
//		if (readCount <= 0) {
//			break;
//		}
//
//		strResult += std::string(buffer, readCount);
//	}
//}

//DWORD RequestWebGetData(CString strSessionName,CString strServerUrl, std::string &strResult, bool bSecureFlag /*= true*/)
//{
//	DWORD dwHttpRequestFlags = INTERNET_FLAG_RELOAD | INTERNET_FLAG_DONT_CACHE | INTERNET_FLAG_NO_AUTO_REDIRECT;
//
//	if( bSecureFlag )
//		dwHttpRequestFlags |= INTERNET_DEFAULT_HTTPS_PORT | INTERNET_FLAG_SECURE | INTERNET_FLAG_IGNORE_CERT_DATE_INVALID | INTERNET_FLAG_IGNORE_CERT_CN_INVALID | SECURITY_INTERNET_MASK | SECURITY_SET_MASK;
//
//
//	CInternetSession session(strSessionName); 
//	session.SetOption(INTERNET_OPTION_CONNECT_TIMEOUT, 10000);
//	session.SetOption(INTERNET_OPTION_SEND_TIMEOUT, 10000);
//	session.SetOption(INTERNET_OPTION_RECEIVE_TIMEOUT, 10000);
//	CHttpConnection* pServer = NULL; 
//	CHttpFile *pFile = NULL;
//	BOOL bRet = FALSE;
//	DWORD dwRet = 0;
//
//	try 
//	{ 
//		//ERROR_INTERNET_INVALID_CA
//		CString strServerName; 
//		CString strObject; 
//		INTERNET_PORT nPort; 
//		DWORD dwServiceType; 
//		AfxParseURL(strServerUrl, dwServiceType, strServerName, strObject, nPort);
//		LPCWSTR strHeader = L"Content-Type: application/x-www-form-urlencoded\r\n"
//			L"Accept:text/html,application/xhtml+xml,application/xml;q=0.9,*/*;q=0.8\r\n"
//			L"Accept-Encoding: gzip,deflate,sdch\r\n"
//			L"Accept-Language:ko-KR,ko;q=0.8,en-US;q=0.6,en;q=0.4\r\n"
//			L"Accept-Charset: utf-8;\r\n\r\n";
//		// HTTP 컨넥션 연결
//		pServer = session.GetHttpConnection(strServerName, nPort); 
//		ASSERT(pServer);
//		// GET 방식으로 파일 요청
//		pFile = pServer->OpenRequest(CHttpConnection::HTTP_VERB_GET, strObject, NULL, 1, NULL, NULL, dwHttpRequestFlags);
//		ASSERT(pFile);
//		// 요청 전송
//		pFile->SendRequest(strHeader,NULL,0); 
//		// 요청 결과 수신
//		pFile->QueryInfoStatusCode(dwRet);
//		// 만약 요청이 정상이라면
//		if(dwRet == HTTP_STATUS_OK) 
//		{		
//			ResponseWebData(pFile, strResult);
//			bRet = TRUE;
//		} 
//		else
//		{
//			TRACE(_T("err code = %d %s %d\n"),dwRet, __FUNCTION__, __LINE__);
//		}
//	} 
//	catch (CInternetException* pEx) 
//	{ 
//		pEx->Delete();
//
//	}
//	if(pFile)
//	{
//		pFile->Close(); 
//		delete pFile;
//		pFile = NULL;
//	}
//	if(pServer)
//	{
//		pServer->Close(); 
//		delete pServer;
//		pServer = NULL;
//	} 
//	session.Close(); 
//
//	return dwRet;
//}

//DWORD RequestWebPostData(CString strSessionName, CString strServerUrl, std::string strFormData , std::string &strResult, bool bSecureFlag /*= true*/)
//{
//	//http응답 결과
//	DWORD dwHttpRequestFlags =  INTERNET_FLAG_RELOAD;
//
//	if( bSecureFlag )
//		dwHttpRequestFlags |= INTERNET_DEFAULT_HTTPS_PORT | INTERNET_FLAG_SECURE | INTERNET_FLAG_IGNORE_CERT_DATE_INVALID | INTERNET_FLAG_IGNORE_CERT_CN_INVALID | SECURITY_INTERNET_MASK | SECURITY_SET_MASK;
//
//	CInternetSession session(strSessionName); 
//	session.SetOption(INTERNET_OPTION_CONNECT_TIMEOUT, 50000);
//	session.SetOption(INTERNET_OPTION_SEND_TIMEOUT, 50000);
//	session.SetOption(INTERNET_OPTION_RECEIVE_TIMEOUT, 50000);
//	CHttpConnection* pServer = NULL; 
//	CHttpFile *pFile = NULL;
//	DWORD dwRet = 0;
//	BOOL bRet = FALSE;
//	try 
//	{ 
//		CString strServerName; 
//		CString strObject; 
//		INTERNET_PORT nPort; 
//		DWORD dwServiceType; 
//		CString strServerURL = strServerUrl;
//		AfxParseURL(strServerURL, dwServiceType, strServerName, strObject, nPort); 
//		// HTTP 컨넥션 연결
//		pServer = session.GetHttpConnection(strServerName, nPort); 
//		pFile = pServer->OpenRequest(CHttpConnection::HTTP_VERB_POST, strObject, NULL, 1, NULL, NULL, dwHttpRequestFlags);
//		CString strHeader = L"Content-Type: application/x-www-form-urlencoded\r\n"
//			L"Accept: text/html,application/xhtml+xml,application/xml;q=0.9,*/*;q=0.8\r\n"
//			L"Accept-Encoding: gzip,deflate,sdch\r\nAccept-Language: ko-KR,ko;q=0.8,en-US;q=0.6,en;q=0.4\r\n"
//			L"Accept-Charset: utf-8;\r\n\r\n";
//		const char *lpFormData = strFormData.c_str(); 
//		const size_t dwLen = strFormData.length();
//
//		// 요청 전송
//		VERIFY(pFile->SendRequest(strHeader,(LPVOID)lpFormData,dwLen)); 
//		// 요청 결과 수신
//		pFile->QueryInfoStatusCode(dwRet);
//		// 만약 요청이 정상이라면
//		if(dwRet == HTTP_STATUS_OK) 
//		{		
//			ResponseWebData(pFile, strResult);
//			bRet = TRUE;
//		} 
//		else
//		{
//			TRACE(_T("err code = %d %s %d\n"),dwRet, __FUNCTION__, __LINE__);
//		}
//	} 
//	catch (CInternetException* pEx) 
//	{ 
//		pEx->Delete();
//	}
//	if(pFile)
//	{
//		pFile->Close(); 
//		delete pFile;
//		pFile = NULL;
//	}
//	if(pServer)
//	{
//		pServer->Close(); 
//		delete pServer;
//		pServer = NULL;
//	} 
//	session.Close(); 
//	return dwRet;
//}

CString UTF8ToUnicode(const char *utf8_string, int length)
{
	int wcsLen = ::MultiByteToWideChar(CP_UTF8, NULL, utf8_string, length, NULL, 0);   
	wchar_t* wszString = new wchar_t[wcsLen + 1];
	::MultiByteToWideChar(CP_UTF8, NULL, utf8_string, length, wszString, wcsLen);
	wszString[wcsLen] = '\0';
	CString unicodeText(wszString); 
	delete[] wszString;
	return unicodeText;
}

std::string UnicodeToUTF8(CString strUnicode)
{
	const size_t dwLen = WideCharToMultiByte(CP_UTF8, 0, strUnicode, -1, NULL, 0, NULL, NULL);
	char *buf = new char[dwLen];
	if (NULL == buf)
	{
		return "";
	}

	WideCharToMultiByte(CP_UTF8,0,strUnicode,-1,buf,dwLen,0,0);
	std::string	strResult(buf);
	delete[] buf;
	return strResult;
}

char* StringToChar(CString str)
{
	char *szStr = NULL;
#if defined(UNICODE) || defined(_UNICODE)
	int nLen = str.GetLength() + 1;
	TCHAR *tszTemp = NULL;
	tszTemp = new TCHAR[nLen];
	if(tszTemp == NULL)
		return NULL;

	memset(tszTemp, 0x00, nLen*sizeof(TCHAR));
	_tcscpy_s(tszTemp, nLen, str);
	// Get size (실제사용되는바이트사이즈)
	int nSize = WideCharToMultiByte(CP_ACP, 0, tszTemp, -1, NULL, NULL, NULL, NULL);
	szStr = new char[nSize];
	if (szStr == NULL)
	{
		delete [] tszTemp;
		return NULL;
	}

	memset(szStr, 0x00, nSize);
	WideCharToMultiByte(CP_ACP, 0, tszTemp, -1, szStr, nSize, NULL, NULL);

	delete [] tszTemp;
#else
	int nLen = str.GetLength() + 1;
	szStr = new char[nLen];
	memset(szStr, 0x00, nLen);
	strcpy(szStr, str);
#endif
	return szStr;
}

std::string UnicodeToURIEncode(const CString &strUnicode)
{
	std::string	strResult;
	strResult= UriEncode(UnicodeToUTF8(strUnicode));
	return strResult;
}

CString CharToString(char *str)
{
	CString cStr;
#if defined(UNICODE) || defined(_UNICODE)
	int nLen = strlen(str) + 1;
	TCHAR *tszTemp = NULL;
	tszTemp = new TCHAR[nLen];
	if(tszTemp == NULL)
		return _T("");
	memset(tszTemp, 0x00, nLen*sizeof(TCHAR));
	MultiByteToWideChar(CP_ACP, 0, str, -1, tszTemp, nLen);
	cStr.Format(_T("%s"), tszTemp);
	if(tszTemp)
	{
		delete [] tszTemp;
		tszTemp = NULL;
	}

#else
	cStr.Format("%s", str);
#endif

	return cStr;
}

size_t Split(const CString& text, const CString& delimiter, bool bWithDelimeter, std::vector<CString>& tokens)
{
	int len = text.GetLength();
	int start = 0;
	int stop = text.Find(delimiter, start);
	while (-1 != stop)
	{
		if (bWithDelimeter && start > 0)
		{
			tokens.push_back(text.Mid(start - 1, stop - start + 1));
		}
		else
		{
			tokens.push_back(text.Mid(start, stop - start));
		}
		start = stop + delimiter.GetLength();
		stop = text.Find(delimiter, start);
	}
	if (start >0 && start < len)
	{
		tokens.push_back(text.Mid(start));
	}

	return tokens.size();
}

int GetLocaleTime(CTime* t)
{
	switch(GET_CONFIG()->GetGMT())
	{
	case 0:		*t -= CTimeSpan(0, 12, 0, 0);		break;
	case 1:		*t -= CTimeSpan(0, 11, 0, 0);		break;
	case 2:		*t -= CTimeSpan(0, 10, 0, 0);		break;
	case 3:		*t -= CTimeSpan(0, 9, 0, 0);		break;
	case 4:		*t -= CTimeSpan(0, 8, 0, 0);		break;
	case 5:		*t -= CTimeSpan(0, 7, 0, 0);		break;
	case 6:		*t -= CTimeSpan(0, 6, 0, 0);		break;
	case 7:		*t -= CTimeSpan(0, 5, 0, 0);		break;
	case 8:		*t -= CTimeSpan(0, 4, 0, 0);		break;
	case 9:		*t -= CTimeSpan(0, 3, 0, 0);		break;
	case 10:	*t -= CTimeSpan(0, 2, 0, 0);		break;
	case 11:	*t -= CTimeSpan(0, 1, 0, 0);		break;
	case 12:	*t -= CTimeSpan(0, 0, 0, 0);		break;
	case 13:	*t += CTimeSpan(0, 1, 0, 0);		break;
	case 14:	*t += CTimeSpan(0, 2, 0, 0);		break;
	case 15:	*t += CTimeSpan(0, 3, 0, 0);		break;
	case 16:	*t += CTimeSpan(0, 3, 30, 0);		break;
	case 17:	*t += CTimeSpan(0, 4, 0, 0);		break;
	case 18:	*t += CTimeSpan(0, 4, 30, 0);		break;
	case 19:	*t += CTimeSpan(0, 5, 0, 0);		break;
	case 20:	*t += CTimeSpan(0, 5, 30, 0);		break;
	case 21:	*t += CTimeSpan(0, 5, 45, 0);		break;
	case 22:	*t += CTimeSpan(0, 6, 0, 0);		break;
	case 23:	*t += CTimeSpan(0, 6, 30, 0);		break;
	case 24:	*t += CTimeSpan(0, 7, 0, 0);		break;
	case 25:	*t += CTimeSpan(0, 8, 0, 0);		break;
	case 26:	*t += CTimeSpan(0, 9, 0, 0);		break;
	case 27:	*t += CTimeSpan(0, 9, 30, 0);		break;
	case 28:	*t += CTimeSpan(0, 10, 0, 0);		break;
	case 29:	*t += CTimeSpan(0, 11, 0, 0);		break;
	case 30:	*t += CTimeSpan(0, 12, 0, 0);		break;
	case 31:	*t += CTimeSpan(0, 13, 0, 0);		break;
	default:	*t += CTimeSpan(0, 9, 0, 0);		break;
	}
	return GET_CONFIG()->GetGMT();
}

int GetGMTTime(CTime* t)
{
    switch(GET_CONFIG()->GetGMT())
    {
    case 0:		*t += CTimeSpan(0, 12, 0, 0);		break;
    case 1:		*t += CTimeSpan(0, 11, 0, 0);		break;
    case 2:		*t += CTimeSpan(0, 10, 0, 0);		break;
    case 3:		*t += CTimeSpan(0, 9, 0, 0);		break;
    case 4:		*t += CTimeSpan(0, 8, 0, 0);		break;
    case 5:		*t += CTimeSpan(0, 7, 0, 0);		break;
    case 6:		*t += CTimeSpan(0, 6, 0, 0);		break;
    case 7:		*t += CTimeSpan(0, 5, 0, 0);		break;
    case 8:		*t += CTimeSpan(0, 4, 0, 0);		break;
    case 9:		*t += CTimeSpan(0, 3, 0, 0);		break;
    case 10:	*t += CTimeSpan(0, 2, 0, 0);		break;
    case 11:	*t += CTimeSpan(0, 1, 0, 0);		break;
    case 12:	*t += CTimeSpan(0, 0, 0, 0);		break;
    case 13:	*t -= CTimeSpan(0, 1, 0, 0);		break;
    case 14:	*t -= CTimeSpan(0, 2, 0, 0);		break;
    case 15:	*t -= CTimeSpan(0, 3, 0, 0);		break;
    case 16:	*t -= CTimeSpan(0, 3, 30, 0);		break;
    case 17:	*t -= CTimeSpan(0, 4, 0, 0);		break;
    case 18:	*t -= CTimeSpan(0, 4, 30, 0);		break;
    case 19:	*t -= CTimeSpan(0, 5, 0, 0);		break;
    case 20:	*t -= CTimeSpan(0, 5, 30, 0);		break;
    case 21:	*t -= CTimeSpan(0, 5, 45, 0);		break;
    case 22:	*t -= CTimeSpan(0, 6, 0, 0);		break;
    case 23:	*t -= CTimeSpan(0, 6, 30, 0);		break;
    case 24:	*t -= CTimeSpan(0, 7, 0, 0);		break;
    case 25:	*t -= CTimeSpan(0, 8, 0, 0);		break;
    case 26:	*t -= CTimeSpan(0, 9, 0, 0);		break;
    case 27:	*t -= CTimeSpan(0, 9, 30, 0);		break;
    case 28:	*t -= CTimeSpan(0, 10, 0, 0);		break;
    case 29:	*t -= CTimeSpan(0, 11, 0, 0);		break;
    case 30:	*t -= CTimeSpan(0, 12, 0, 0);		break;
    case 31:	*t -= CTimeSpan(0, 13, 0, 0);		break;
    default:	*t -= CTimeSpan(0, 9, 0, 0);		break;
    }
    return GET_CONFIG()->GetGMT();
}

CTime StringToCTime(CString strTime)
{
	//자르는 타임기본값 _T("2008-11-12 14:54:00");
	if (strTime.IsEmpty())
	{
		return CTime(0);
	}
	int nYear = _wtoi(strTime.Left(4));
	int nMon = _wtoi(strTime.Mid(5,2));
	int nDay = _wtoi(strTime.Mid(8,2));
	int nHour = _wtoi(strTime.Mid(11,2));
	int nMin = _wtoi(strTime.Mid(14,2));
	int nSec = _wtoi(strTime.Mid(17,2));

	try
	{
		CTime ct(nYear, nMon, nDay, nHour, nMin, nSec);
		return ct;
	}
	catch (...)
	{
		return CTime(0);
	}
}

CString CTimeToCString(CTime ct)
{
	CString strDateTime;
	strDateTime.Format(_T("%04d-%02d-%02d %02d:%02d:%02d"),ct.GetYear(),ct.GetMonth(),ct.GetDay(),ct.GetHour(),ct.GetMinute(),ct.GetSecond());
	return strDateTime;
}

INT64 CTimeToInt(const CTime& ct)
{
	INT64 nTime = ct.GetTime();

	return nTime;
}

CString LocalTimeConvert(CString strTime)
{
	if(strTime==L"")
	{
		return L"0";
	}
	CTime t= StringToCTime(strTime);
	GetLocaleTime(&t);
	return CTimeToCString(t);
}

int SplitString(LPCTSTR pszSrc, TCHAR split, vector<CString> &rvec)
{
	rvec.clear();

	CString strSrc, strTokenize;
	int nStart = 0;

	strSrc = pszSrc;
	int nPos = strSrc.Find(split);
	while (-1 != nPos)
	{
		CString strToken;
		if (nPos == nStart)
		{
			strToken = _T("");
		}
		else
		{
			strToken = strSrc.Mid(nStart, nPos - nStart);
		}

		rvec.push_back(strToken);

		nStart = nPos + 1;
		nPos = strSrc.Find(split, nStart);

		if (-1 == nPos
			&& nStart <= strSrc.GetLength())
		{
			strToken = strSrc.Mid(nStart, strSrc.GetLength() - nStart);
			rvec.push_back(strToken);
		}
	}

	return rvec.size();
}

int SplitString_NotEmpty(LPCTSTR pszSrc, TCHAR split, vector<CString> &rvec)
{
	CString strSrc, strTokenize;
	int nPos = 0;
	int nPosOld = nPos;
	CString strTmp;

	strSrc = pszSrc;

	while(1)
	{
		nPos = strSrc.Find(split, nPosOld);
		if(nPos == -1)
		{
			if(strSrc.GetLength() == nPosOld)
			{
				rvec.push_back(_T(""));
			}
			else if(strSrc.GetLength() > nPosOld)
			{
				strTmp = strSrc.Mid(nPosOld, strSrc.GetLength());				
				rvec.push_back(strTmp);
			}
			break;
		}
		if(nPosOld == nPos)
		{
			rvec.push_back(_T(""));

		}
		else
		{
			strTmp = strSrc.Mid(nPosOld, (nPos - nPosOld));
			rvec.push_back(strTmp);
		}

		nPosOld = nPos + 1;

	}

	return rvec.size();
}

// 주의: LoadStringFromResource()함수의 응답을 TCHAR* 로 받아서 사용하면 크래쉬가 발생할 수 있으니 
//       반드시 CString 타입으로 받아서 사용해야 한다.
CString LoadStringFromResource(UINT nID)
{
	CString strRet;
	strRet.LoadString(nID);

	return strRet;
}

CCommonFunction::CCommonFunction(void)
{
}

CCommonFunction::~CCommonFunction(void)
{
}

/*!
* @brief     내트워크 연결 상태 체크
* @return    BOOL : TRUE이면 연결중이다.
* @param     void 
* @author    Jaehoon.Kim(jaehoon.kim@nhn.com)
* @date      2012-03-07
* @warning   
*/
BOOL CCommonFunction::GetNetworkStatus()
{
	DWORD dwStatus;
	return InternetGetConnectedState(&dwStatus, NULL);
}


const CString GetProductVersion()
{
    TCHAR temp_path[MAX_PATH + 1] = {0};
	CString strResult;
	GetModuleFileName(AfxGetInstanceHandle(), temp_path, _countof(temp_path));
	DWORD h_version_handle = 0;
	DWORD version_info_size = GetFileVersionInfoSize(temp_path, &h_version_handle);
	HANDLE h_memory = GlobalAlloc(GMEM_MOVEABLE, version_info_size); 
	LPVOID p_info_memory = GlobalLock(h_memory);
	GetFileVersionInfo(temp_path, h_version_handle, version_info_size, p_info_memory);
	char *p_data = NULL;

	UINT data_size = 0;

	if(VerQueryValue(p_info_memory, _T("\\StringFileInfo\\041203b5\\FileVersion"), (void **)&p_data, &data_size))
	{ 
		strResult.Format(_T("%s"),(TCHAR*)p_data);
	}
	GlobalUnlock(h_memory); 
	GlobalFree(h_memory);


	return strResult;
}

BOOL UtilFillSolidRect(HDC hdc,const RECT *rc,COLORREF color)
{
	BOOL isDrawed=FALSE;
	COLORREF prevColor=SetBkColor(hdc,color);
	if (prevColor!=CLR_INVALID)
	{
		isDrawed=ExtTextOut(hdc,0,0,ETO_OPAQUE,rc,NULL,0,NULL);
		SetBkColor(hdc,prevColor);
	}

	return isDrawed;
}

const std::string Conversion::WideToUtf8(const std::wstring& wideString)
{
	int length = ::WideCharToMultiByte(CP_UTF8, 0, wideString.c_str(), wideString.size(), NULL, 0, NULL, NULL);
	if(0 == length)
		return "";

	char *szUtf8String = (char *) malloc(length);
	if (NULL == szUtf8String)
	{
		return "";
	}

	::WideCharToMultiByte(CP_UTF8, 0, wideString.c_str(), wideString.size(), szUtf8String, length, NULL, NULL);
	std::string utf8String(szUtf8String, length);
	free(szUtf8String);

	return utf8String;
}

//const std::string Conversion::WideToAcp(const std::wstring& wideString)
//{
//	int length = ::WideCharToMultiByte(CP_ACP, 0, wideString.c_str(), wideString.size(), NULL, 0, NULL, NULL);
//	if (0 == length)
//	{
//		return "";
//	}
//
//	char *szUtf8String = (char *) malloc(length);
//	if (NULL == szUtf8String)
//	{
//		return "";
//	}
//
//	::WideCharToMultiByte(CP_UTF8, 0, wideString.c_str(), wideString.size(), szUtf8String, length, NULL, NULL);
//	std::string utf8String(szUtf8String, length);
//	free(szUtf8String);
//
//	return utf8String;
//}

const std::wstring Conversion::Utf8ToWide(const std::string& utf8String)
{
	std::wstring wideString = _T("");

	int length = ::MultiByteToWideChar(CP_UTF8, 0, utf8String.c_str(), utf8String.size(), NULL, 0);
	if (0 == length)
		return _T("");

	std::vector<wchar_t> szWideString;
	szWideString.resize(length);
	if (length > 0)
	{
		::MultiByteToWideChar(CP_UTF8, 0, utf8String.c_str(), utf8String.size(), &*szWideString.begin(), length);
	}
	else
	{
		return _T("");
	}

	wideString.assign(szWideString.begin(), szWideString.end());

	return wideString;
}

//const std::wstring Conversion::AcpToWide(const std::string& utf8String)
//{
//	int length = ::MultiByteToWideChar(CP_ACP, 0, utf8String.c_str(), utf8String.size(), NULL, 0);
//	if (0 == length)
//		return _T("");
//
//	std::vector<wchar_t> szWideString;
//	szWideString.resize(length);
//	if (length > 0)
//	{
//		::MultiByteToWideChar(CP_ACP, 0, utf8String.c_str(), utf8String.size(), &*szWideString.begin(), length);
//	}
//	else
//	{
//		return _T("");
//	}
//
//	std::wstring wideString;
//	wideString.assign(szWideString.begin(), szWideString.end());
//
//	return wideString;
//}

CString GetIPTPresenceTip( NTIPTStatusType iptStatus )
{
	CString strStateName;

	switch (iptStatus)
	{
	case iptstIDLE:
		strStateName = LoadStringFromResource(IDS_STRING_MAIN_TOOLTIP_6_1);//GetAppDUIImgDir() + _T("\\img_main_title_ipticon_call.png");
		break;
	case iptstACTIVE:
		strStateName = LoadStringFromResource(IDS_STRING_MAIN_TOOLTIP_15_2);//GetAppDUIImgDir() + _T("\\img_main_title_ipticon_busy.png");
		break;
	case itpstALERTING:
		strStateName = LoadStringFromResource(IDS_STRING_MAIN_TOOLTIP_15_2);//GetAppDUIImgDir() + _T("\\img_main_title_ipticon_busy.png");
		break;
	case itpstHELD:
		strStateName = LoadStringFromResource(IDS_STRING_MAIN_TOOLTIP_6_2);// + _T("\\img_main_title_ipticon_waitcall.png");
		break;
	case iptstUNKNOWN:
		strStateName = _T(""); 
		break;
	case iptstNA:
		strStateName = _T("");
		break;
	case iptstDND:
		strStateName =LoadStringFromResource(IDS_STRING_MAIN_TOOLTIP_6_3);// GetAppDUIImgDir() + _T("\\img_main_title_ipticon_nocall.png");
		break;
	case iptstFWD:
		strStateName = LoadStringFromResource(IDS_STRING_MAIN_TOOLTIP_6_4);//GetAppDUIImgDir() + _T("\\img_main_title_ipticon_changcall.png");
		break;	
	default:
		strStateName = _T("");
		break;
	}

	return strStateName;
}

CString GetPresenceTip(int type)
{
	CString tString(_T(""));

	BOOL bMobile = (type & ustMOBILE);
	type &= ~ustMOBILE;
	switch(type)
	{
	case  ustOFFLINE:
		tString = LoadStringFromResource(IDS_PRESENCE_OFFLINE);
		break;
	case  ustONLINE:
		tString = LoadStringFromResource(IDS_PRESENCE_ONLINE);
		break;
	case  ustAWAY:
	case  ustAUTOAWAY:
		tString = LoadStringFromResource(IDS_PRESENCE_AWAY);
		break;
	case  ustBUSY:
		tString = LoadStringFromResource(IDS_PRESENCE_BUSY);
		break;
	case  ustOUTSIDE:
		tString = LoadStringFromResource(IDS_PRESENCE_OUT);
		break;
	case  ustEAT:
		tString = LoadStringFromResource(IDS_PRESENCE_EATING);
		break;
	case  ustMEETING:
		tString = LoadStringFromResource(IDS_PRESENCE_MEETING);
		break;
	//case ustOFFLINE  | ustMOBILE:	
	//	tString = LoadStringFromResource(IDS_PRESENCE_OFFLINE);
	//	break;
	//case ustONLINE	 | ustMOBILE:	
	//	tString = LoadStringFromResource(IDS_PRESENCE_M_ONLINE);
	//	break;
	//case ustAWAY	 | ustMOBILE:
	//case ustAUTOAWAY | ustMOBILE:	
	//	tString = LoadStringFromResource(IDS_PRESENCE_M_AWAY);
	//	break;
	//case ustBUSY	 | ustMOBILE:		
	//	tString = LoadStringFromResource(IDS_PRESENCE_M_BUSY);
	//	break;
	//case ustOUTSIDE  | ustMOBILE:	
	//	tString = LoadStringFromResource(IDS_PRESENCE_M_OUT);
	//	break;
	//case ustEAT		 | ustMOBILE:	
	//	tString = LoadStringFromResource(IDS_PRESENCE_M_EATING);
	//	break;
	//case ustMEETING  | ustMOBILE:	
	//	tString = LoadStringFromResource(IDS_PRESENCE_M_MEETING);
	//	break;
	default:
		tString = LoadStringFromResource(IDS_PRESENCE_OFFLINE);
	}
    if (bMobile)
    {

		if (type!=ustONLINE && type!=ustOFFLINE )
		{
			tString += _T("(") + LoadStringFromResource(IDS_PRESENCE_M_ONLINE) +_T(")") ;
		}
		else if (type ==ustONLINE ) {
			//tString = LoadStringFromResource(IDS_PRESENCE_M_ONLINE);
		}
		else if (type ==ustOFFLINE ) {
			tString = LoadStringFromResource(IDS_PRESENCE_M_ONLINE);
		}
    }

	return tString;
}
BOOL CreateDirectoryTree(LPCTSTR lptzPath)
{
	ASSERT ( lptzPath );
	if ( !lptzPath )
		return FALSE;

	BOOL    bRet = TRUE;
	int     nLen = _tcslen ( lptzPath ) + 1;
	LPTSTR  lptzBuf = new TCHAR[nLen];
	memset ( lptzBuf, 0x00, nLen * sizeof (TCHAR) );

	for ( LPCTSTR lptzCursor = lptzPath; _T('\0') != *lptzCursor; lptzCursor++ )
	{
		if ( _T('\\') == *lptzCursor )
		{
			// 문자열이 계속 길어지므로 memset은 필요없다.
			_tcsncpy_s ( lptzBuf, nLen, lptzPath, lptzCursor - lptzPath );
			if (::PathFileExists(lptzBuf))
			{
				if (!::PathIsDirectory(lptzBuf))
				{
					//there is a same name file 
					SetLastError(ERROR_BAD_PATHNAME);
					bRet = FALSE;
					break;
				}
			}
			else if ( !CreateDirectory ( lptzBuf, NULL ) )
			{
				// 디렉토리가 이미 존재해서 실패한 경우는 에러가 아니다.
				//if ( ERROR_ALREADY_EXISTS != GetLastError () )
				{
					bRet = FALSE;
					break;
				}
			}
		}
	}

	delete[] lptzBuf;

	// lptzPath의 마지막에 '\\'가 없을 경우 마지막 디렉토리를 생성한다.
	if ( bRet )
	{
		bRet = CreateDirectory ( lptzPath, NULL );
	}
	return bRet;
}

BOOL RegisterWindowClass(const TCHAR* pszClassName)
{
	WNDCLASS wndcls;
	HINSTANCE hInst;
	hInst = AfxGetInstanceHandle();

	ASSERT(hInst != 0);

	if (!(::GetClassInfo(hInst, pszClassName, &wndcls)))
	{
		wndcls.style            = CS_DBLCLKS | CS_HREDRAW | CS_VREDRAW;
		wndcls.lpfnWndProc      = ::DefWindowProc;
		wndcls.cbClsExtra       = 0;
		wndcls.cbWndExtra		= 0;
		wndcls.hInstance        = hInst;
		wndcls.hIcon            = NULL;
		wndcls.hCursor          = AfxGetApp()->LoadStandardCursor(IDC_ARROW);
		wndcls.hbrBackground    = (HBRUSH)(COLOR_WINDOW);
		wndcls.lpszMenuName     = NULL;
		wndcls.lpszClassName    = pszClassName;

		if (!AfxRegisterClass(&wndcls))
		{
			AfxThrowResourceException();
			return FALSE;
		}
	}

	return TRUE;
}

CString GetNtalkModulePath()
{
	CString strAppModuleDir = _T("");

	TCHAR lpszFileName[_MAX_PATH] = _T("");
	GetModuleFileName(AfxGetInstanceHandle(), lpszFileName, _MAX_PATH);

	CString strModule(lpszFileName);	
	int nLength = strModule.GetLength();
	int nPos = strModule.ReverseFind('\\');
	CString strFileName = strModule.Mid(nPos + 1, nLength - nPos);

	strAppModuleDir = strModule.Left(nPos);
	return strAppModuleDir;
}

CString GetAppImgDir()
{
	return (GetNtalkModulePath() + _T("\\IMAGES"));
}

CString GetAppDUIImgDir()
{
	return (GetNtalkModulePath() + _T("\\skin\\nTalkRes"));
}

CString GetMyDocNtalkDir()
{
	TCHAR szMyDocumentPath[MAX_PATH] = {0,};
	SHGetSpecialFolderPath(NULL, szMyDocumentPath, CSIDL_MYDOCUMENTS, TRUE);

	CString strNtalkDataDir;
	strNtalkDataDir.Format(_T("%s\\Ntalk biz"), szMyDocumentPath);
	CreateDirectory(strNtalkDataDir, NULL);

	return strNtalkDataDir;
}

CString GetAppDataNtalkDir()
{
	TCHAR szMyDocumentPath[MAX_PATH] = {0,};
	SHGetSpecialFolderPath(NULL, szMyDocumentPath, CSIDL_LOCAL_APPDATA, TRUE);

	CString strNtalkDataDir;
	strNtalkDataDir.Format(_T("%s\\Ntalkbiz"), szMyDocumentPath);
	CreateDirectory(strNtalkDataDir, NULL);

	return strNtalkDataDir;
}

void DeleteDirectory(CString strDir)    
{
	if(strDir.IsEmpty())
		return;

	CFileFind ff;

	BOOL bFound = ff.FindFile(strDir + _T("\\*.*"), 0);

	while (bFound)
	{
		bFound = ff.FindNextFile();

		if(ff.GetFileName() == _T(".") || ff.GetFileName() == _T(".."))
			continue;

		SetFileAttributes(ff.GetFilePath(), FILE_ATTRIBUTE_NORMAL);

		if(ff.IsDirectory())
		{
			DeleteDirectory(ff.GetFilePath());
			RemoveDirectory(ff.GetFilePath());
		}
		else
		{
			DeleteFile(ff.GetFilePath());
		}
	}

	ff.Close();
	RemoveDirectory(strDir);
}

CString GetAppMemoDir()
{
	CString strNtalkDataDir;
	strNtalkDataDir = GetMyDocNtalkDir();

	CString strMemoDir;
	strMemoDir.Format(_T("%s\\Memo"), strNtalkDataDir);
	CreateDirectory(strMemoDir, NULL);

	return strMemoDir;
}

CString GetSmartEditorDir()
{
	return (GetNtalkModulePath() + _T("\\SmartEditor2"));
}

CString InsertCharToString(CString strOrigin, int nPos, TCHAR ch)
{
	CString strRet = _T("");
	TCHAR tchNow = _T('');
	CString strPrev = _T("");
	int nLen = strOrigin.GetLength();

	int nCount = 0;
	for (int i = nLen - 1; i >= 0; i--, nCount++)
	{
		if (nCount > 0 && (nCount % nPos == 0))
		{
			strPrev.Insert(0, ch);
		}

		tchNow = strOrigin.GetAt(i);
		strRet = tchNow;
		strRet += strPrev;

		strPrev = strRet;
	}

	return strRet;
}

BOOL DrawImageToDest(Graphics* pGraph, Image* pImg, CRect* pRtPS, CRect* pRtImg, ImageAttributes* pImgAttr)
{
	if (pImg)
	{
		CRect rtIntersect(0, 0, 0, 0);
		int nISX = 0, nISY = 0, nICX = 0, nICY = 0, nImgWidth = 0, nImgHeight = 0;
		int nDSX = 0, nDSY = 0, nDCX = 0, nDCY = 0;

		nImgWidth = pImg->GetWidth();
		nImgHeight = pImg->GetHeight();

		if (rtIntersect.IntersectRect(pRtPS, pRtImg))
		{
			nDSX = pRtImg->left - pRtPS->left;
			nDSY = pRtImg->top - pRtPS->top;
			nDCX = pRtImg->Width();
			nDCY = pRtImg->Height();

			nISX = 0;
			nISY = 0;
			nICX = nImgWidth;
			nICY = nImgHeight;

			RectF rf((Gdiplus::REAL)nDSX, (Gdiplus::REAL)nDSY, (Gdiplus::REAL)nDCX, (Gdiplus::REAL)nDCY);
			

			pGraph->DrawImage(pImg, rf, (Gdiplus::REAL)nISX, (Gdiplus::REAL)nISY, (Gdiplus::REAL)nICX, (Gdiplus::REAL)nICY, UnitPixel, pImgAttr);

			return TRUE;
		}
	}

	return FALSE;
}

BOOL DrawImageToDest(Graphics* pGraph, Image* pImg, CRect* pRtPS, CRect* pRtImg, CRect* pRtSrc, ImageAttributes* pImgAttr)
{
	if (pImg)
	{
		CRect rtIntersect(0, 0, 0, 0);
		int nISX = 0, nISY = 0, nICX = 0, nICY = 0;
		int nDSX = 0, nDSY = 0, nDCX = 0, nDCY = 0;

		if (rtIntersect.IntersectRect(pRtPS, pRtImg))
		{
			nDSX = pRtImg->left - pRtPS->left;
			nDSY = pRtImg->top - pRtPS->top;
			nDCX = pRtImg->Width();
			nDCY = pRtImg->Height();

			nISX = pRtSrc->left;
			nISY = pRtSrc->top;
			nICX = pRtSrc->Width();
			nICY = pRtSrc->Height();

			RectF rf((Gdiplus::REAL)nDSX, (Gdiplus::REAL)nDSY, (Gdiplus::REAL)nDCX, (Gdiplus::REAL)nDCY);

			pGraph->DrawImage(pImg, rf, (Gdiplus::REAL)nISX, (Gdiplus::REAL)nISY, (Gdiplus::REAL)nICX, (Gdiplus::REAL)nICY, UnitPixel, pImgAttr);

			return TRUE;
		}
	}

	return FALSE;
}

void DrawImageToStretchHorz(Graphics* pGraph, Image* pImg, CRect* pRtPS, CRect* pRtImg, Color crVert, ImageAttributes* pImgAttr)
{
	if (pImg)
	{
		InterpolationMode ipModeSave = pGraph->GetInterpolationMode();

		pGraph->SetInterpolationMode(InterpolationModeDefault);

		CRect rtIntersect(0, 0, 0, 0);
		int nISX = 0, nISY = 0, nICX = 0, nICY = 0, nImgWidth = 0, nImgHeight = 0;
		int nDSX = 0, nDSY = 0, nDCX = 0, nDCY = 0;

		nImgWidth = pImg->GetWidth();
		nImgHeight = pImg->GetHeight();

		CRect rt = *pRtImg;

		BOOL bLastRect = FALSE;

		int nSX = pRtImg->left;
		for (int i = nSX; i < pRtImg->right; )
		{
			rt.left = nSX;
			rt.right = rt.left + nImgWidth;
			if (rt.right >= pRtImg->right)
			{
				rt.right = pRtImg->right + 1;
				bLastRect = TRUE;
			}

			if (rtIntersect.IntersectRect(pRtPS, &rt))
			{
				nDSX = rt.left - pRtPS->left;
				nDSY = rt.top - pRtPS->top;
				nDCX = rt.Width();
				nDCY = nImgHeight;

				nISX = 0;
				nISY = 0;
				nICX = nImgWidth;
				nICY = nImgHeight;

				RectF rf((Gdiplus::REAL)nDSX, (Gdiplus::REAL)nDSY, (Gdiplus::REAL)nDCX, (Gdiplus::REAL)nDCY);

				pGraph->DrawImage(pImg, rf, (Gdiplus::REAL)nISX, (Gdiplus::REAL)nISY, (Gdiplus::REAL)nICX, (Gdiplus::REAL)nICY, UnitPixel, pImgAttr);
			}

			if (bLastRect)
				break;

			nSX += nImgWidth;
		}

		if (pRtImg->Height() > nImgHeight)
		{
			SolidBrush brush(crVert);
			nDSX = pRtImg->left - pRtPS->left;
			nDSY += nImgHeight;
			nDCX = pRtImg->Width();
			nDCY = pRtImg->Height();
			pGraph->FillRectangle(&brush, nDSX, nDSY, nDCX, nDCY);
		}

		pGraph->SetInterpolationMode(ipModeSave);
	}
}

void DrawImageToStretchHorzExceptL(Graphics* pGraph, Image* pImg, CRect* pRtPS, CRect* pRtImg, int nPixel, ImageAttributes* pImgAttr)
{
	if (pImg)
	{
		InterpolationMode ipModeSave = pGraph->GetInterpolationMode();

		pGraph->SetInterpolationMode(InterpolationModeDefault);

		CRect rtIntersect(0, 0, 0, 0);
		int nISX = 0, nISY = 0, nICX = 0, nICY = 0, nImgWidth = 0, nImgHeight = 0;
		int nDSX = 0, nDSY = 0, nDCX = 0, nDCY = 0;

		nImgWidth = pImg->GetWidth();
		nImgHeight = pImg->GetHeight();

		CRect rt = *pRtImg;

		BOOL bLastRect = FALSE;

		int nSX = pRtImg->left;
		for (int i = nSX; i < pRtImg->right; )
		{
			rt.left = nSX;
			rt.right = rt.left + nImgWidth - nPixel;
			if (rt.right >= pRtImg->right)
			{
				rt.right = pRtImg->right + 1;
				bLastRect = TRUE;
			}

			if (rtIntersect.IntersectRect(pRtPS, &rt))
			{
				nDSX = rt.left - pRtPS->left;
				nDSY = rt.top - pRtPS->top;
				nDCX = rt.Width();
				nDCY = nImgHeight;

				nISX = nPixel;
				nISY = 0;
				nICX = nImgWidth - nPixel;
				nICY = nImgHeight;

				RectF rf((Gdiplus::REAL)nDSX, (Gdiplus::REAL)nDSY, (Gdiplus::REAL)nDCX, (Gdiplus::REAL)nDCY);

				pGraph->DrawImage(pImg, rf, (Gdiplus::REAL)nISX, (Gdiplus::REAL)nISY, (Gdiplus::REAL)nICX, (Gdiplus::REAL)nICY, UnitPixel, pImgAttr);
			}

			if (bLastRect)
				break;

			nSX += (nImgWidth - nPixel);
		}

		nDSX = pRtImg->left - pRtPS->left;
		nDSY = pRtImg->top - pRtPS->top;
		nDCX = nPixel;
		nDCY = nImgHeight;

		nISX = 0;
		nISY = 0;
		nICX = nPixel;
		nICY = nImgHeight;

		RectF rf((Gdiplus::REAL)nDSX, (Gdiplus::REAL)nDSY, (Gdiplus::REAL)nDCX, (Gdiplus::REAL)nDCY);

		pGraph->DrawImage(pImg, rf, (Gdiplus::REAL)nISX, (Gdiplus::REAL)nISY, (Gdiplus::REAL)nICX, (Gdiplus::REAL)nICY, UnitPixel, pImgAttr);

		pGraph->SetInterpolationMode(ipModeSave);
	}
}

void DrawTextToDest(Graphics* pGraph,
					CString strText, CRect* pRtPS, CRect* pRtText,
					int nSX, int nSY,
					WCHAR* wszFontName, int nFontHeight,
					Gdiplus::StringAlignment alignment, Gdiplus::FontStyle style,
					Color crPen, int nPenWidth,
					BOOL bGradient,
					Color crFill1, Color crFill2)
{
	CRect rtIntersect(0, 0, 0, 0);
	int nISX = 0, nISY = 0, nICX = 0, nICY = 0, nImgWidth = 0, nImgHeight = 0;
	int nDSX = 0, nDSY = 0, nDCX = 0, nDCY = 0;

	if ((strText.GetLength() > 0) && (rtIntersect.IntersectRect(pRtPS, pRtText)))
	{
		nDSX = pRtText->left - pRtPS->left;
		nDSY = pRtText->top - pRtPS->top;

		FontFamily fontFamily(wszFontName);
		StringFormat format;
		format.SetAlignment(alignment);
		GraphicsPath path;
		path.AddString(strText,
			strText.GetLength(),
			&fontFamily, style,
			(Gdiplus::REAL)nFontHeight,
			Point(nDSX + nSX, nDSY + nSY),
			&format);
		Pen pen(crPen, (Gdiplus::REAL)nPenWidth);
		pGraph->DrawPath(&pen, &path);

		LinearGradientMode linearGradientMode = LinearGradientModeVertical;
		Rect rtFill(0, 0, pRtText->Width(), pRtText->Height());
		LinearGradientBrush linGrBrush(Point(0, pRtText->Height() / 2 - 5), Point(0, 0), crFill1, crFill2);
		WrapMode wrap = WrapModeTileFlipXY;
		linGrBrush.SetWrapMode(wrap);
		pGraph->FillPath(&linGrBrush, &path);

		if (bGradient)
		{
			for (int i = 1; i < 5; i += 1)
			{
				Pen pen2(Color(255 / i, 5, 5, 5), (Gdiplus::REAL)i);
				pen2.SetLineJoin(LineJoinRound);
				pGraph->DrawPath(&pen2, &path);
			}
		}
	}
}

void DrawTextToDest2(Graphics* pGraph,
					 CString strText, CRect* pRtPS, CRect* pRtText,
					 WCHAR* wszFontName, REAL nFontHeight,
					 Gdiplus::StringAlignment alignment, Gdiplus::FontStyle style,
					 Color crPen, StringFormatFlags strFormatFlags)
{
	CRect rtIntersect(0, 0, 0, 0);
	int nISX = 0, nISY = 0, nICX = 0, nICY = 0, nImgWidth = 0, nImgHeight = 0;
	int nDSX = 0, nDSY = 0, nDCX = 0, nDCY = 0;

	if ((strText.GetLength() > 0) && (rtIntersect.IntersectRect(pRtPS, pRtText)))
	{
		nDSX = pRtText->left - pRtPS->left;
		nDSY = pRtText->top - pRtPS->top;

		Gdiplus::Font myFont(wszFontName, nFontHeight, style);
		StringFormat format;
		format.SetAlignment(alignment);
		format.SetLineAlignment(StringAlignmentCenter);
		format.SetFormatFlags(strFormatFlags);		
		format.SetTrimming(StringTrimmingEllipsisCharacter);
		//format.SetFormatFlags(StringFormatFlagsNoFitBlackBox);
		SolidBrush brush(crPen);

		RectF layoutRect((Gdiplus::REAL)nDSX,
			(Gdiplus::REAL)nDSY,
			(Gdiplus::REAL)(pRtText->Width()),
			(Gdiplus::REAL)(pRtText->Height()));		

		pGraph->DrawString(strText,
			strText.GetLength(),
			&myFont,
			layoutRect,
			&format,
			&brush);
	}
}

void RecalcTextRect(CWnd* pWnd, CString strText, WCHAR* wszFontName, REAL& nFontHeight, Gdiplus::FontStyle style, CRect rtBound, CSize& szBound)
{
	int nWidth = rtBound.Width() * 2;
	int nHeight = rtBound.Height() * 2;

	if (pWnd)
	{
		Graphics graph(pWnd->m_hWnd);
		graph.SetPageUnit(UnitPixel);

		StringFormat format;
		format.SetAlignment(Gdiplus::StringAlignmentNear);
		RectF layoutRect(0.0, 0.0, (Gdiplus::REAL)nWidth, (Gdiplus::REAL)nHeight);
		
		do
		{
			Gdiplus::Font myFont(wszFontName, nFontHeight, style);
			RectF boundingBox;

			graph.MeasureString(strText, strText.GetLength(), &myFont, layoutRect, &format, &boundingBox);
			if (boundingBox.Width <= rtBound.Width() && boundingBox.Height <= rtBound.Height())
			{
				szBound.cx = (LONG)(boundingBox.Width) + 1;
				szBound.cy = (LONG)(boundingBox.Height) + 1;

				break;
			}
			nFontHeight--;
		} while (TRUE);

	}
}

int RecalcTextRect3(CWnd* pWnd, CString strText, WCHAR* wszFontName, REAL& nFontHeight, Gdiplus::FontStyle style, CRect rtBound, CSize& szBound)
{
	int nWidth = rtBound.Width() ;
	int nHeight = rtBound.Height() ;
	int trimLen = 0;

	if (pWnd)
	{
		Graphics graph(pWnd->m_hWnd);
		graph.SetPageUnit(UnitPixel);

		StringFormat format;
		format.SetAlignment(Gdiplus::StringAlignmentNear);
		RectF layoutRect(0.0, 0.0, (Gdiplus::REAL)nWidth, (Gdiplus::REAL)nHeight);
		do
		{
			Gdiplus::Font myFont(wszFontName, nFontHeight, style);
			RectF boundingBox;

			graph.MeasureString(strText, strText.GetLength() - trimLen, &myFont, layoutRect, &format, &boundingBox);
			if (boundingBox.Width <= rtBound.Width() && boundingBox.Height <= rtBound.Height())
			{
				szBound.cx = (LONG)(boundingBox.Width) + 1;
				szBound.cy = (LONG)(boundingBox.Height) + 1;

				break;
			}
			trimLen++;
			//nFontHeight--;
		} while (TRUE);
	}
	return trimLen;
}

void RecalcTextRectVert2(CWnd* pWnd, CString strText, WCHAR* wszFontName, REAL nFontHeight, 
						 Gdiplus::FontStyle style, CRect rtBound, CSize& szBound)
{
	CSize szBoundSingleLine(0, 0);
	RecalcTextRectVert(pWnd, strText, wszFontName, nFontHeight, style, rtBound, szBound);

	rtBound.right = INT_MAX;
	CString strSingleLine = strText;
	strSingleLine.Remove('\r');
	strSingleLine.Remove('\n');
	RecalcTextRectVert(pWnd, strSingleLine, wszFontName, nFontHeight, style, rtBound, szBoundSingleLine);

	FontFamily fontFamily(wszFontName);
	Gdiplus::Font font(&fontFamily, nFontHeight, style,UnitPixel);
	Graphics graph(pWnd->m_hWnd);
	REAL fSingleLineHeight = font.GetHeight(&graph); 

	int iSingleLineHeight = ceil(fSingleLineHeight);
	int iDeviation = szBoundSingleLine.cy - iSingleLineHeight;

	szBound.cy -= iDeviation;


}

void RecalcTextRectVert(CWnd* pWnd, CString strText, WCHAR* wszFontName, REAL nFontHeight, 
						Gdiplus::FontStyle style, CRect rtBound, CSize& szBound,
						BOOL bWrap /*= TRUE*/)
{
	int nWidth = rtBound.Width();
	int nHeight = rtBound.Height() * 100;


	if (pWnd)
	{
		Graphics graph(pWnd->m_hWnd);
		graph.SetPageUnit(UnitPixel);

		StringFormat format;
		format.SetAlignment(Gdiplus::StringAlignmentNear);
		if(!bWrap)
		{
			format.SetFormatFlags(StringFormatFlagsNoWrap);
		}
		RectF layoutRect(0.0, 0.0, (Gdiplus::REAL)nWidth, (Gdiplus::REAL)nHeight);

		Gdiplus::Font myFont(wszFontName, nFontHeight, style);
		RectF boundingBox;
		graph.MeasureString(strText, strText.GetLength(), &myFont, layoutRect, &format, &boundingBox);
		szBound.cx = (LONG)(boundingBox.Width) + 1;
		szBound.cy = (LONG)(boundingBox.Height) + 1;
	}
}

void RecalcTextRect2(CWnd* pWnd, CString strText, WCHAR* wszFontName, int& nFontHeight, int nThickness, CRect rtBound, CSize& szBound)
{
	int nWidth = rtBound.Width() * 2;
	int nHeight = rtBound.Height() * 2;

	RectF rtDraw;
	rtDraw.X = (Gdiplus::REAL)(rtBound.left);
	rtDraw.Y = (Gdiplus::REAL)(rtBound.top);
	rtDraw.Width = (Gdiplus::REAL)nWidth;
	rtDraw.Height = (Gdiplus::REAL)nHeight;

	if (pWnd)
	{
		Graphics graph(pWnd->m_hWnd);
		graph.SetPageUnit(UnitPixel);

		FontFamily fontFamily(wszFontName);
		StringFormat format;
		format.SetAlignment(Gdiplus::StringAlignmentNear);
		
		float fDestWidth = 0.0f;
		float fDestHeight = 0.0f;

		do
		{
			GraphicsPath path;
			Status status = path.AddString(strText, strText.GetLength(), &fontFamily, Gdiplus::FontStyleRegular, (Gdiplus::REAL)nFontHeight, rtDraw, &format);
			if (status != Ok)
				break;

			fDestWidth = rtDraw.GetLeft();
			fDestHeight = rtDraw.GetTop();

			MeasureGraphicsPath(&graph, &path, &fDestWidth, &fDestHeight);

			float pixelThick = 0.0f;
			BOOL bConvert = ConvertToPixels(&graph, (float)nThickness, 0.0f, &pixelThick, NULL);
			if (!bConvert)
				break;

			fDestWidth += pixelThick;
			fDestHeight += pixelThick;

			if (fDestWidth < rtBound.Width() && fDestHeight < rtBound.Height())
			{
				szBound.cx = (LONG)fDestWidth;
				szBound.cy = (LONG)fDestHeight;

				break;
			}
			nFontHeight--;
		} while (TRUE);
	}
}

BOOL MeasureGraphicsPath(Graphics* pGraphics, GraphicsPath* pGraphicsPath, float* pfPixelsWidth, float* pfPixelsHeight)
{
	if (!pGraphics || !pGraphicsPath || !pfPixelsWidth || !pfPixelsHeight)
		return FALSE;

	PathData pathData;
	Status status = pGraphicsPath->GetPathData(&pathData);

	if (status != Ok)
		return FALSE;

	if (pathData.Count <= 0)
		return FALSE;

	float fHighestX = pathData.Points[0].X;
	float fHighestY = pathData.Points[0].Y;
	float fLowestX = pathData.Points[0].X;
	float fLowestY = pathData.Points[0].Y;
	//pathData.Points[0];
	for (int i = 1; i < pathData.Count; i++)
	{
		if (pathData.Points[i].X < fLowestX)
			fLowestX = pathData.Points[i].X;
		if (pathData.Points[i].Y < fLowestY)
			fLowestY = pathData.Points[i].Y;
		if (pathData.Points[i].X > fHighestX)
			fHighestX = pathData.Points[i].X;
		if (pathData.Points[i].Y > fHighestY)
			fHighestY = pathData.Points[i].Y;
	}

	if (fLowestX < 0.0f)
		fLowestX = -fLowestX;
	else
		fLowestX = 0.0f;

	if (fLowestY < 0.0f)
		fLowestY = -fLowestY;
	else
		fLowestY = 0.0f;

	BOOL bConvert = ConvertToPixels(pGraphics,
		fLowestX + fHighestX - *pfPixelsWidth,
		fLowestY + fHighestY - *pfPixelsHeight,
		pfPixelsWidth,
		pfPixelsHeight);

	return bConvert;
}

BOOL ConvertToPixels(Graphics* pGraphics, float fSrcWidth, float fSrcHeight, float* pfDestWidth, float* pfDestHeight)
{
	if (!pGraphics)
		return FALSE;

	Unit unit = pGraphics->GetPageUnit();
	float fDpiX = pGraphics->GetDpiX();
	float fDpiY = pGraphics->GetDpiY();

	if (unit == UnitWorld)
		return FALSE;

	if (unit == UnitDisplay || unit == UnitPixel)
	{
		if (pfDestWidth)
			*pfDestWidth = fSrcWidth;
		if (pfDestHeight)
			*pfDestHeight = fSrcHeight;
		return TRUE;
	}

	if (unit == UnitPoint)
	{
		if (pfDestWidth)
			*pfDestWidth = 1.0f/72.0f * fDpiX * fSrcWidth;
		if (pfDestHeight)
			*pfDestHeight = 1.0f/72.0f * fDpiY * fSrcHeight;
		return TRUE;
	}

	if (unit == UnitInch)
	{
		if (pfDestWidth)
			*pfDestWidth = fDpiX * fSrcWidth;
		if (pfDestHeight)
			*pfDestHeight = fDpiY * fSrcHeight;
		return TRUE;
	}

	if (unit == UnitDocument)
	{
		if (pfDestWidth)
			*pfDestWidth = 1.0f/300.0f * fDpiX * fSrcWidth;
		if (pfDestHeight)
			*pfDestHeight = 1.0f/300.0f * fDpiY * fSrcHeight;
		return TRUE;
	}

	if (unit == UnitMillimeter)
	{
		if (pfDestWidth)
			*pfDestWidth = 1.0f/25.4f * fDpiX * fSrcWidth;
		if (pfDestHeight)
			*pfDestHeight = 1.0f/25.4f * fDpiY * fSrcHeight;
		return TRUE;
	}

	return FALSE;
}

HRGN BitmapToRegion(HBITMAP hBmp, COLORREF cTransparentColor, COLORREF cTolerance)
{
	if (hBmp == NULL)
		return NULL;

	HRGN hRgn = NULL;
	HDC hMemDC = CreateCompatibleDC(NULL);

	if (hMemDC)
	{
		BITMAP bm;
		GetObject(hBmp, sizeof(bm), &bm);

		BITMAPINFOHEADER RGB32BITSBITMAPINFO = {
			sizeof(BITMAPINFOHEADER),	// biSize 
			bm.bmWidth,					// biWidth; 
			bm.bmHeight,				// biHeight; 
			1,							// biPlanes; 
			32,							// biBitCount 
			BI_RGB,						// biCompression; 
			0,							// biSizeImage; 
			0,							// biXPelsPerMeter; 
			0,							// biYPelsPerMeter; 
			0,							// biClrUsed; 
			0							// biClrImportant; 
		};

		void* pbits32 = NULL;
		HBITMAP hbm32 = CreateDIBSection(hMemDC, (BITMAPINFO*)&RGB32BITSBITMAPINFO, DIB_RGB_COLORS, &pbits32, NULL, 0);

		if (hbm32)
		{
			HBITMAP hOld32Bmp = (HBITMAP)SelectObject(hMemDC, hbm32);

			HDC hDC = CreateCompatibleDC(hMemDC);
			if (hDC)
			{
				BITMAP bm32;
				GetObject(hbm32, sizeof(bm32), &bm32);
				while (bm32.bmWidthBytes % 4)
					bm32.bmWidthBytes++;

				HBITMAP holdBmp = (HBITMAP)SelectObject(hDC, hBmp);
				BitBlt(hMemDC, 0, 0, bm.bmWidth, bm.bmHeight, hDC, 0, 0, SRCCOPY);

#define ALLOC_UNIT	100
				DWORD maxRects = ALLOC_UNIT;
				HANDLE hData = GlobalAlloc(GMEM_MOVEABLE, sizeof(RGNDATAHEADER) + (sizeof(RECT) * maxRects));
				RGNDATA* pData = (RGNDATA*)GlobalLock(hData);
				pData->rdh.dwSize = sizeof(RGNDATAHEADER);
				pData->rdh.iType = RDH_RECTANGLES;
				pData->rdh.nCount = pData->rdh.nRgnSize = 0;
				SetRect(&pData->rdh.rcBound, MAXLONG, MAXLONG, 0, 0);

				BYTE lr = GetRValue(cTransparentColor);
				BYTE lg = GetGValue(cTransparentColor);
				BYTE lb = GetBValue(cTransparentColor);
				BYTE hr = min(0xff, lr + GetRValue(cTolerance));
				BYTE hg = min(0xff, lg + GetGValue(cTolerance));
				BYTE hb = min(0xff, lb + GetBValue(cTolerance));

				BYTE* p32 = (BYTE*)bm32.bmBits + (bm32.bmHeight - 1) * bm32.bmWidthBytes;
				for (int y = 0; y < bm.bmHeight; y++)
				{
					for (int x = 0; x < bm.bmWidth; x++)
					{
						int x0 = x;
						LONG* p = (LONG*)p32 + x;
						while (x < bm.bmWidth)
						{
							BYTE b = GetRValue(*p);
							if (b >= lr && b <= hr)
							{
								b = GetGValue(*p);
								if (b >= lg && b <= hg)
								{
									b = GetBValue(*p);
									if (b >= lb && b <= hb)
										break;
								}
							}
							p++;
							x++;
						}

						if (x > x0)
						{
							if (pData->rdh.nCount >= maxRects)
							{
								GlobalUnlock(hData);
								maxRects += ALLOC_UNIT;
								hData = GlobalReAlloc(hData, sizeof(RGNDATAHEADER) + (sizeof(RECT) * maxRects), GMEM_MOVEABLE);
								pData = (RGNDATA*)GlobalLock(hData);
							}
							RECT* pr = (RECT*)&pData->Buffer;
							SetRect(&pr[pData->rdh.nCount], x0, y, x, y+1);
							if (x0 < pData->rdh.rcBound.left)
								pData->rdh.rcBound.left = x0;
							if (y < pData->rdh.rcBound.top)
								pData->rdh.rcBound.top = y;
							if (x > pData->rdh.rcBound.right)
								pData->rdh.rcBound.right = x;
							if (y+1 > pData->rdh.rcBound.bottom)
								pData->rdh.rcBound.bottom = y+1;
							pData->rdh.nCount++;

							if (pData->rdh.nCount == 2000)
							{
								HRGN h = ExtCreateRegion(NULL, sizeof(RGNDATAHEADER) + (sizeof(RECT) * maxRects), pData);
								if (hRgn)
								{
									CombineRgn(hRgn, hRgn, h, RGN_OR);
									DeleteObject(h);
								}
								else
								{
									hRgn = h;
								}
								pData->rdh.nCount = 0;
								SetRect(&pData->rdh.rcBound, MAXLONG, MAXLONG, 0, 0);
							}
						}
					}

					p32 -= bm32.bmWidthBytes;
				}

				HRGN h = ExtCreateRegion(NULL, sizeof(RGNDATAHEADER) + (sizeof(RECT) * maxRects), pData);
				if (hRgn)
				{
					CombineRgn(hRgn, hRgn, h, RGN_OR);
					DeleteObject(h);
				}
				else
				{
					hRgn = h;
				}

				GlobalUnlock(hData);
				GlobalFree(hData);
				SelectObject(hDC, holdBmp);
				DeleteDC(hDC);
			}

			SelectObject(hMemDC, hOld32Bmp);
			DeleteObject(hbm32);
		}
	
		DeleteDC(hMemDC);
	}

	return hRgn;
}
HBITMAP LoadPngToBmp(CString strPath, COLORREF colorTranslate)
{
	HBITMAP hBitmap;

	CImage image;
	if(image.Load(strPath) != S_OK)
	{
		return NULL;
	}

	HDC hDC, dcMem;
	hDC = GetDC(NULL);
	dcMem = ::CreateCompatibleDC(hDC);
	
	int cx = image.GetWidth();
	int cy = image.GetHeight();
	hBitmap = ::CreateCompatibleBitmap(hDC, cx, cy);

	HBITMAP hOldBitmap = (HBITMAP)::SelectObject(dcMem, hBitmap);

	::SetBkColor(dcMem, colorTranslate);
	CRect rect(0, 0, 0 + cx, 0 + cy);
	::ExtTextOut(dcMem, 0, 0, ETO_OPAQUE, &rect, NULL, 0, NULL);

	image.AlphaBlend(dcMem, 0, 0);
	::SelectObject(dcMem, hOldBitmap);
	::DeleteDC(dcMem);

	return hBitmap;
}

CString RecalcTextString(CWnd* pWnd, CString strText, WCHAR* wszFontName, REAL nFontHeight, Gdiplus::FontStyle style, CRect rtBound)
{
	int nWidth = rtBound.Width() * 2;
	int nHeight = rtBound.Height() * 2;

	CString strAbbrText = _T("");

	if (pWnd)
	{
		Graphics graph(pWnd->m_hWnd);
		graph.SetPageUnit(UnitPixel);

		StringFormat format;
		format.SetAlignment(Gdiplus::StringAlignmentNear);
		RectF layoutRect(0.0,
			0.0,
			(Gdiplus::REAL)nWidth,
			(Gdiplus::REAL)nHeight);
		Gdiplus::Font myFont(wszFontName, nFontHeight, style);

		CString strMsg = _T("");
		CString strTest = _T("");

		int nLen = strText.GetLength();
		for (int i = 0; i < nLen; i++)
		{
			TCHAR tch = strText.GetAt(i);

			strTest += tch;

			RectF boundingBox;

			graph.MeasureString(strTest,
				strTest.GetLength(),
				&myFont,
				layoutRect,
				&format,
				&boundingBox);

			if (boundingBox.Width > rtBound.Width())
			{
				int j = i - 1;
				BOOL bPass = FALSE;
				if (i <= (nLen - 1))
				{
					while (!bPass)
					{
						strAbbrText += _T("...");

						RectF boundingBox2;

						graph.MeasureString(strAbbrText,
							strAbbrText.GetLength(),
							&myFont,
							layoutRect,
							&format,
							&boundingBox2);

						if (boundingBox2.Width > rtBound.Width())
						{
							int nAbbrLen = strAbbrText.GetLength();
							strAbbrText.Delete(j, nAbbrLen - j);

							if (j-- <= 0)
								bPass = TRUE;
						}
						else
							bPass = TRUE;
					}
				}
				break;
			}
			else
			{
				strAbbrText = strTest;
			}
		}
	}
	return strAbbrText;
}

GraphicsPath* MakeRoundRect(Point topLeft, Point bottomRight, int nOffsetX, int nOffsetY)
{
	int left  = min(topLeft.X, bottomRight.X);
	int right = max(topLeft.X, bottomRight.X);

	int top    = min(topLeft.Y, bottomRight.Y);
	int bottom = max(topLeft.Y, bottomRight.Y);

	//int offsetX = (right - left) * percentageRounded / 100;
	//int offsetY = offsetX;

	GraphicsPath pt(FillModeWinding);
	GraphicsPath* path = pt.Clone();

	path->AddArc(right-nOffsetX, top, nOffsetX, nOffsetY, 270, 90);

	path->AddArc(right-nOffsetX, bottom-nOffsetY, nOffsetX, nOffsetY, 0, 90);

	path->AddArc(left, bottom - nOffsetY, nOffsetX, nOffsetY, 90, 90);

	path->AddArc(left, top, nOffsetX, nOffsetY, 180, 90);

	path->AddLine(left + nOffsetX, top, right - nOffsetX / 2, top);

	return path;
}

int GetStringCount(CString& strString, TCHAR chParse, CStringArray* pAr)
{
	if (strString.IsEmpty())
		return 0;

	if (pAr)
		pAr->RemoveAll();

	const int iLength = strString.GetLength();

	int iTotalCount = 0, iFind = 0, iCount = 0;

	CString strTemp = _T("");
	while (((iFind = strString.Find(chParse, iCount)) != -1))
	{
		strTemp = strString.Mid(iCount, iFind - iCount);
		if (pAr)
			pAr->Add(strTemp);

		iCount = iFind + 1;

		iTotalCount++;
	}

	if (iCount != iLength)
	{
		strTemp = strString.Mid(iCount, (iLength - iCount));
		if (pAr)
			pAr->Add(strTemp);
	}

	return iCount == iLength ? iTotalCount : iTotalCount + 1;
}

CString GetAppImgFile( CString strFileName )
{
	CString strImageFilePath;
	strImageFilePath.Format(_T("%s\\%s"), GetAppImgDir(), strFileName);

	return strImageFilePath;
}

void InputMethod::SetDefaultInputMethod(HWND hwnd)
{
	if (NULL != hwnd)
	{
		HIMC himc=ImmGetContext(hwnd);
		ImmSetConversionStatus(himc, IME_CMODE_NATIVE,IME_SMODE_CONVERSATION);
		ImmReleaseContext(hwnd,himc);    
	}
}
CString CTimeConversion::GetStringDayOfWeek( CTime &startTime )
{

	if(g_stNtalkInfo.nLang == NTALK_LANG_KOREAN) 
	{
		switch(startTime.GetDayOfWeek())
		{
		case 1:
			return L"일";
		case 2:
			return L"월";
		case 3:
			return L"화";
		case 4:
			return L"수";
		case 5:
			return L"목";
		case 6:
			return L"금";
		case 7:
			return L"토";
		default:
			return L"";

		}
	}
	else
	{
		switch(startTime.GetDayOfWeek())
		{
		case 1:
			return L"Sun";
		case 2:
			return L"Mon";
		case 3:
			return L"Tue";
		case 4:
			return L"Wed";
		case 5:
			return L"Thu";
		case 6:
			return L"Fri";
		case 7:
			return L"Sat";
		default:
			return L"";

		}
	}
}

const CTime CTimeConversion::GetKoreaTime()
{
	SYSTEMTIME timeGMT;
	::GetSystemTime(&timeGMT);    // 현재 GMT시간을 가져온다.
	CTime curTime(timeGMT);   

	CTimeSpan timeKorea(0,9,0,0);
	curTime += timeKorea;


	return curTime;		
}

const std::string CodecConversion::URLdecode( const std::string& aSrc )
{
	std::ostringstream result;
	for(std::string::size_type x=0;x<aSrc.size();++x)
		switch(aSrc[x])
	{
		case('+'):
			{
				result<<' ';
				break;
			}
		case('%'): // Convert all %xy hex codes into ASCII characters.
			{
				const std::string hexstr(aSrc.substr(x+1,2)); // xy part of %xy.
				x+=2; // Skip over hex.
				if(hexstr=="26" || hexstr=="3D")
					// Do not alter URL delimeters.
					result<<'%'<<hexstr;
				else
				{
					std::istringstream hexstream(hexstr);
					int hexint;
					hexstream>>std::hex>>hexint;
					result<<static_cast<char>(hexint);
				}
				break;
			}
		default: // Copy anything else.
			{
				result<<aSrc[x];
				break;
			}
	}
	return result.str();
}
HWND g_hTooltip = NULL;
HWND g_hTooltipParent = NULL;
bool ShowTooltip(HWND parent, CString strMsg)
{
    if (!::IsWindow(parent)){
	  return false;
    }
    if (g_hTooltipParent != NULL && g_hTooltipParent != parent)
    {
        //parent already change, must re-create new tool tip
        HideTooltip(g_hTooltipParent, true);
        g_hTooltipParent = NULL;
    }

    if (NULL == g_hTooltip)
    {
        g_hTooltip = CreateWindowEx(WS_EX_TOPMOST, TOOLTIPS_CLASS, NULL, WS_POPUP | TTS_NOPREFIX | TTS_ALWAYSTIP, 
            CW_USEDEFAULT, CW_USEDEFAULT, CW_USEDEFAULT, CW_USEDEFAULT, 
            parent, NULL, AfxGetInstanceHandle(),NULL);
        if (!g_hTooltip)
        {
            return false;
        }
        g_hTooltipParent = parent;
        ::SendMessage(g_hTooltip, TTM_SETMAXTIPWIDTH, 0, 5000); //allow \r\n in tooltips

        //UINT nDoubleClickTime = GetDoubleClickTime();
        //::SendMessage(g_hTooltip, TTM_SETDELAYTIME, TTDT_INITIAL, nDoubleClickTime);
        //::SendMessage(g_hTooltip, TTM_SETDELAYTIME, TTDT_AUTOPOP, nDoubleClickTime * 5);
        //::SendMessage(g_hTooltip, TTM_SETDELAYTIME, TTDT_RESHOW, nDoubleClickTime * 10);
    }

	//::ShowWindow(g_hTooltip,SW_SHOWNA);
	 
    POINT pt = {0};
	 ::GetCursorPos(&pt);
	
	TOOLINFO ti = { 0 };
	ti.cbSize   = sizeof(TOOLINFO);
	ti.uFlags   = TTF_SUBCLASS;
	ti.hwnd     = parent;
	
	ti.hinst    = AfxGetInstanceHandle();
	ti.lpszText = strMsg.GetBuffer(); //.GetBuffer();
    
	::GetClientRect (parent, &ti.rect);
	::SendMessage(g_hTooltip, TTM_ADDTOOL, 0, (LPARAM) (LPTOOLINFO) &ti);	
    strMsg.ReleaseBuffer();
	return true;
}

void RelayTooTipEvent(HWND parent, LPMSG pMsg)
{
    if (g_hTooltip)
    {
        ::SendMessage(g_hTooltip, TTM_RELAYEVENT, 0, (LPARAM)pMsg);
    }
}
bool HideTooltip(HWND parent, bool bDestroyWnd)
{
    if (g_hTooltip)
    {
        TOOLINFO ti = { 0 };
        ti.cbSize   = sizeof(TOOLINFO);
        ti.uFlags   = 0;
        ti.hwnd     = parent;
        ti.hinst    = AfxGetInstanceHandle();
        ti.lpszText = L"";
        ::SendMessage(g_hTooltip, TTM_DELTOOL, 0, (LPARAM) (LPTOOLINFO) &ti);	

        if (bDestroyWnd)
        {
            ::DestroyWindow(g_hTooltip);
            g_hTooltip = NULL;
        }
    }
    return false;
}

VOID DrawIntervalMessageText(CDC* pDC, const CString& strText, const CRect& rcText, UINT nFormat, int yTextInterVal)
{
	int nTop = rcText.top;
	CString strTmp = strText;
	int nPos = strTmp.Find(TEXT('\n'));
	while (nPos > 0)
	{
		CString strCur = strTmp.Left(nPos);
		CRect rcTmpText(0, 0, 0, 0);
		rcTmpText.top = nTop;
		rcTmpText.left = rcText.left;
		pDC->DrawText(strCur, strCur.GetLength(), &rcTmpText, nFormat| DT_CALCRECT);
		rcTmpText.right = rcText.right;
		pDC->DrawText(strCur, strCur.GetLength(), &rcTmpText, nFormat);
		nTop += rcTmpText.Height();
		nTop += yTextInterVal;
		strTmp = strTmp.Right(strTmp.GetLength() - nPos - 1);
		nPos = strTmp.Find(TEXT('\n'));
	}
	if (!strTmp.IsEmpty())
	{
		CRect rcTmpText = rcText;
		rcTmpText.top = nTop;
		rcTmpText.left = rcText.left;
		pDC->DrawText(strTmp, strTmp.GetLength(), &rcTmpText, nFormat | DT_CALCRECT);
		rcTmpText.right = rcText.right;
		pDC->DrawText(strTmp, strTmp.GetLength(), &rcTmpText, nFormat);
	}
}


Color CColorConvert::HEX2Color(UINT hex){
  return Color(GetBValue(hex), GetGValue(hex), GetRValue(hex));
   
}

UINT CColorConvert::Color2HEX(Color color)
{
	ARGB argb = color.GetValue();
	return argb & 0x00FFFFFF;
}



void  LogFile(LPCTSTR lpszFormat, ...)
{   
	/*wchar_t FilePath[MAX_PATH+1]= {0};
	wchar_t *p = NULL;
	GetModuleFileName(NULL, FilePath, sizeof(FilePath)); //获取程序当前执行文件名
	p=_tcsrchr(FilePath, '\\');                       
	*p='\0';*/

	CString FilePath =  GET_APP()->GetAppDataDir();
	FilePath += _T("\\log");
	//wcscat_s(FilePath,_T("\\TIMER.txt"));
	FilePath += _T("\\TIMER.txt");

	va_list   args;
	int       nBuf;
    wchar_t     szBuffer[512] = {0};
	va_start(args, lpszFormat);
	nBuf = _vsnwprintf(szBuffer, _countof(szBuffer), lpszFormat, args);	
	va_end(args);
	FILE* pFile = _tfopen(FilePath, _T("a+"));
	if (NULL != pFile)
	{
		fwprintf(pFile, _T("%ws\n"),szBuffer);
		fclose(pFile);
	}	
}


BOOL DrawNineBlockImage(Gdiplus::Graphics* pGraphics, Gdiplus::Image* pImages[9], const Gdiplus::RectF* pRec)
{
	ImageAttributes ImgAtt;
	ImgAtt.SetWrapMode(WrapModeTileFlipXY);

	INT vx = pRec->Width - pImages[0]->GetWidth() - pImages[2]->GetWidth();
	INT vy = pRec->Height - pImages[0]->GetHeight() - pImages[6]->GetHeight();
	vx = max(0, vx);
	vy = max(0, vy);
	INT sx = pRec->GetLeft();
	INT sy = pRec->GetTop();

	RectF rcDst0(sx, sy, pImages[0]->GetWidth(), pImages[0]->GetHeight());

	pGraphics->DrawImage(pImages[0], rcDst0, 0, 0, pImages[0]->GetWidth(), pImages[0]->GetHeight(), UnitPixel, &ImgAtt);
	sx += pImages[0]->GetWidth();

	RectF rcDst1(sx, sy, vx, pImages[1]->GetHeight());
	pGraphics->DrawImage(pImages[1], rcDst1, 0, 0, pImages[1]->GetWidth(), pImages[1]->GetHeight(), UnitPixel, &ImgAtt);
	sx += vx;

	RectF rcDst2(sx, sy, pImages[2]->GetWidth(), pImages[2]->GetHeight());
	pGraphics->DrawImage(pImages[2], rcDst2, 0, 0, pImages[2]->GetWidth(), pImages[2]->GetHeight(), UnitPixel, &ImgAtt);

	sx = pRec->GetLeft();
	sy += pImages[2]->GetHeight();

	RectF rcDst3(sx, sy, pImages[3]->GetWidth(), vy);
	pGraphics->DrawImage(pImages[3], rcDst3, 0, 0, pImages[3]->GetWidth(),  pImages[3]->GetHeight(), UnitPixel, &ImgAtt);
	sx += pImages[3]->GetWidth();

	RectF rcDst4(sx, sy, vx, vy);
	pGraphics->DrawImage(pImages[4], rcDst4, 0, 0, pImages[4]->GetWidth(),pImages[4]->GetHeight(), UnitPixel, &ImgAtt);
	sx += vx;

	RectF rcDst5(sx, sy, pImages[5]->GetWidth(), vy);
	pGraphics->DrawImage(pImages[5],rcDst5, 0, 0, pImages[5]->GetWidth(), pImages[5]->GetHeight(), UnitPixel, &ImgAtt);

	sx =pRec->GetLeft();
	sy += vy;

	RectF rcDst6(sx, sy, pImages[6]->GetWidth(), pImages[6]->GetHeight());
	pGraphics->DrawImage(pImages[6], rcDst6, 0, 0, pImages[6]->GetWidth(), pImages[6]->GetHeight(), UnitPixel, &ImgAtt);

	sx += pImages[6]->GetWidth();
	RectF rcDst7(sx, sy, vx, pImages[7]->GetHeight());
	pGraphics->DrawImage(pImages[7], rcDst7, 0, 0,  pImages[7]->GetWidth(), pImages[7]->GetHeight(), UnitPixel, &ImgAtt);

	sx += vx;
	RectF rcDst8(sx, sy, pImages[8]->GetWidth(), pImages[8]->GetHeight());
	pGraphics->DrawImage(pImages[8], rcDst8, 0, 0, pImages[8]->GetWidth(), pImages[8]->GetHeight(), UnitPixel, &ImgAtt);
	return TRUE;
}